package Alma;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.Color;
import java.awt.Toolkit;

import java.util.ArrayList;
import java.util.Hashtable;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JSplitPane;
import javax.swing.JScrollPane;

import org.jgraph.graph.DefaultGraphCell;
import org.jgraph.graph.DefaultEdge;


public class AboutDialog extends JDialog implements ActionListener {

	private Graph graph;
	private ArrayList graphs, values, ids, tableIdent, initialValues;
	private TableDesign tableDesign;
	private JButton back, forward, reset, zoomM, zoomL, skip;			
	private int row, initY, toBack, toFront, position, before, next;
	private double zoom;
	private String name;
	private boolean isConsult;
	private Hashtable types;
		
  public AboutDialog(JFrame parent, 
		  int row1,
		  ArrayList ids1,
		  ArrayList values,
		  Hashtable types1,
		  String title,
		  boolean isConsult1 ) 
  {
	  super(parent, title, true);

	  Dimension d        = Toolkit.getDefaultToolkit().getScreenSize();
   	  JPanel messagePane = new JPanel();
	  JPanel buttonPane  = new JPanel();
	  this.forward       = new JButton("Forward");			
	  this.reset         = new JButton("Reset");
	  this.zoomM         = new JButton("Zoom +");
	  this.zoomL         = new JButton("Zoom -");
	  this.back          = new JButton("Back");
	  this.skip          = new JButton("Skip"); 

	  this.graph       = new Graph();
	  this.graphs	   = new ArrayList();
	  this.ids	   = new ArrayList();
	  this.tableDesign = new TableDesign();
	  this.tableIdent  = new ArrayList();
	  this.name	   = new String();
	  this.position    = 0;
	  this.zoom	   = 0.8;
	  this.initY       = 150;
	  this.row         = row1;
	  this.isConsult   = isConsult1;
	  this.types	   = types1;

	  setLocation((int)d.getWidth()/2-300,(int)d.getHeight()/2-300);
	  
	  setAndCreateTableArray(ids1,values);
	
	  ArrayList vertexes     = new ArrayList();
	  JPanel left            = new JPanel(new BorderLayout());
	  JPanel panelTable      = new JPanel(new BorderLayout());			
	  JPanel panelButton     = new JPanel();
	  JPanel panel           = new JPanel(new BorderLayout());
	  JScrollPane p = new JScrollPane(this.tableDesign.getTable());
	  JScrollPane right = new JScrollPane();
	  JSplitPane horizontal, vertical;
	
	  p.setPreferredSize(new Dimension(100,180));
	  panelTable.add(new JLabel("Identifiers",JLabel.CENTER),BorderLayout.NORTH);
	  panelTable.add(p,BorderLayout.CENTER);
	  left.add(panelTable, BorderLayout.NORTH);

	  // gets the first step	
	  // in case of consult, we don't show the graph
	  // so we don't need to build it
		if (!this.isConsult)
		{
			if (this.graphs.size() > 0)
			{
				vertexes = (ArrayList)this.graphs.get(0);	
				this.graph.setGraph(vertexes);
				this.graph.getGraph().setScale(zoom);
				right   = new JScrollPane(this.graph.getGraph());
				right.setPreferredSize(new Dimension(400,200));
			}
		}

		panelButton.add(reset);	
		panelButton.add(back);
		panelButton.add(forward);
		panelButton.add(zoomM);
		panelButton.add(zoomL);
		panelButton.add(skip);
		panel.add(panelButton,BorderLayout.CENTER);
		horizontal = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT, left, right);		
		vertical   = new JSplitPane(JSplitPane.VERTICAL_SPLIT, horizontal, panel);
		
		if (this.isConsult)
		{
			this.getContentPane().add(left,BorderLayout.CENTER);
		}
		else
		{
			this.getContentPane().add(vertical);
		}

		this.skip.addActionListener(new java.awt.event.ActionListener() {
          	public void actionPerformed(java.awt.event.ActionEvent e) {
			skipStepByStep();
		}
		});

		this.back.addActionListener(new java.awt.event.ActionListener() {
          	public void actionPerformed(java.awt.event.ActionEvent e) {		
			ArrayList vertexes = new ArrayList();
			ArrayList idents   = new ArrayList();
			
			if (position == graphs.size()-1) 
			{ 
				forward.setEnabled(true);	
			}

			position--;
			before--;
			next--;							
			vertexes = (ArrayList)graphs.get(position);
			idents   = (ArrayList)tableIdent.get(position);
			graph.setGraph(vertexes);
			ident id = (ident)ids.get(row);
			tableDesign.setTableArray(idents,id,types);
			tableDesign.setCellColor(before,next);
			
			//System.out.println(position + " " + before + " " + next + " " + idents);
			if (position == 0) 
			{ 
				back.setEnabled(false);				
			}
          	}
        	});
		this.forward.addActionListener(new java.awt.event.ActionListener() {
		public void actionPerformed(java.awt.event.ActionEvent e) {		
			ArrayList vertexes = new ArrayList();
			ArrayList idents   = new ArrayList();
		
			if (position == 0) 
			{ 
				back.setEnabled(true);	
			}
		
			position++;	
			before++;
			next++;
			vertexes = (ArrayList)graphs.get(position);
			idents   = (ArrayList)tableIdent.get(position);
			graph.setGraph(vertexes);
			ident id = (ident)ids.get(row);
			tableDesign.setTableArray(idents,id,types);
			tableDesign.setCellColor(before,next);
		
			if (position == graphs.size()-1) 
			{ 
				forward.setEnabled(false);	
			}	
          	}
        	});
		this.reset.addActionListener(new java.awt.event.ActionListener() {
		public void actionPerformed(java.awt.event.ActionEvent e) {		
			ArrayList vertexes = new ArrayList();
			ArrayList idents   = new ArrayList();

			back.setEnabled(false);
			forward.setEnabled(true);
			position = 0;	
			before   = -1;
			next     = 0;
			vertexes = (ArrayList)graphs.get(position);
			idents   = (ArrayList)tableIdent.get(position);
			graph.setGraph(vertexes);
			ident id = (ident)ids.get(row);
			tableDesign.setTableArray(idents,id,types);
			tableDesign.setCellColor(before,next);
          	}
        	});

		/*****************************************
		* Zoom + button
		* ***************************************/

		this.zoomM.addActionListener(new java.awt.event.ActionListener() {
          	public void actionPerformed(java.awt.event.ActionEvent e) {
			zoom += 0.1;
			graph.getGraph().setScale(zoom);
          	}
        	});

		/*****************************************
		 * Zoom + button
		 * ***************************************/

		this.zoomL.addActionListener(new java.awt.event.ActionListener() {
          	public void actionPerformed(java.awt.event.ActionEvent e) {
			if (zoom != 0.1)
			{
				zoom -= 0.1;
				graph.getGraph().setScale(zoom);
			}
          	}
        	});

		pack(); 
		if (!this.isConsult)
		{
			this.setSize(750,600);
		}
		else
		{
			this.setSize(310,200);			
		}
		horizontal.setDividerLocation(305);
		vertical.setDividerLocation(520);
		setDefaultCloseOperation(DISPOSE_ON_CLOSE);

	
	        // in case of array already initialized then we block all
		// buttons that allow us to navigate trough graph	
 		if (this.isConsult)
		{
			forward.setEnabled(false);
			back.setEnabled(false);
			reset.setEnabled(false);
			skip.setEnabled(false);
			skipStepByStep();
		}

		setVisible(true);
  }

  	public void skipStepByStep()
	{
		ArrayList vertexes = new ArrayList();
		ArrayList idents   = new ArrayList();

		if (graphs.size() > 0)
		{
			position = graphs.size()-1;
			vertexes = (ArrayList)graphs.get(position);
			idents   = (ArrayList)tableIdent.get(position);
			graph.setGraph(vertexes);
			ident id = (ident)ids.get(row);
			tableDesign.setTableArray(idents,id, this.types);
			before   = values.size()-1;
			next     = -1;

			// we color the cell only if we are initialing the values of
			// array
			if (this.isConsult) {	tableDesign.setCellColor(-1,-1); }
			else 		    {	tableDesign.setCellColor(before,next); }
			forward.setEnabled(false);
			back.setEnabled(false);
		}
	}

	public void setAndCreateTableArray(ArrayList ids, ArrayList v)
	{
		ident id = (ident)ids.get(this.row);
		int i;
		ArrayList idents = new ArrayList();
	
		this.ids    = ids;
		this.name   = id.getName();	
		this.values = v;
		// create graphs for each step of animation
		this.createStepsGraph();
		// initialize the current position in animation
		this.position = 0;
		this.before   = -1;
		this.next     = 0;

		// create table with each id
		for ( i = 0; i < values.size(); i++)
		{
			idents.add(i,"");
		}
		this.tableDesign.createTableArray(idents,id, this.types);
		// change initial color of the table 
		// (red in first row --- will be evaluated)
		this.tableDesign.setCellColor(this.before,this.next);
		back.setEnabled(false);
	}

	private void createStepsGraph()
	{
		int i = 0, j = 0, initX = 250, posY = 0;
		ArrayList vertexes  = new ArrayList();
		ArrayList vertexes2 = new ArrayList();
		ArrayList idents    = new ArrayList();
	    
	        posY = this.values.size()*100;
	        this.createVertex(vertexes, name, 80, posY, Color.GRAY, 60, 30);
	    
	        for (i = 0; i < this.values.size() + 1; i++)
	        {
			if ( i == 0)
			{
				vertexes = createEmptyCells(0);
				this.graphs.add(vertexes);
				for ( j = 0; j < values.size(); j++)
					idents.add("");
				this.tableIdent.add(idents);
			}
			else
			{
				vertexes  = createInitializedCells(i);
				vertexes2 = createEmptyCells(i);
				idents    = createValues(i);
				for ( j = 0; j < vertexes2.size(); j++)
				{	
					vertexes.add(vertexes2.get(j));
				}
				this.graphs.add(vertexes);
				this.tableIdent.add(idents);
			}
			this.initY       = 150;
	    	}
    	}

	private ArrayList createValues(int until)
	{
		int i;
		ArrayList idents = new ArrayList();
		
		for (i = 0; i < until; i++)
	        {
			idents.add(this.values.get(i));
		}

		for(i = until; i < this.values.size(); i++)
		{
			idents.add("");
		}
		
		return idents;	
	}
	
	private ArrayList createEmptyCells(int since)
	{
		int i = 0, initX = 250, posY = 0;
		ArrayList vertexes = new ArrayList();
		Color c = Color.GRAY;        
	        posY = values.size()*100;
		if (since == values.size()) { c = Color.GREEN; }
	        this.createVertex(vertexes, name, 80, posY, c, 120, 30);
		
		for (i = since; i < values.size(); i++)
	        {
			if (i == since) { c = Color.RED; }
			else		{ c = Color.GRAY; }
					
			// node "="
		        this.createVertex(vertexes, "=", initX, initY, c, 120, 30);
		        vertexes = this.createRelation(vertexes, 0, vertexes.size()-1);
		        // node "x[i]"		   
		   	this.createVertex(vertexes, this.name + "[" + i + "]", initX+120, initY-50, c, 120, 30);
		   	vertexes = this.createRelation(vertexes, vertexes.size()-3, vertexes.size()-1);
		   	// node value
		   	this.createVertex(vertexes, this.values.get(i).toString(), initX+120, initY+50, c, 120, 30);
		   	vertexes = this.createRelation(vertexes, vertexes.size()-5, vertexes.size()-1);
		   	initY += 200;
	    	}
		return vertexes;
	}

	private ArrayList createInitializedCells(int until)
	{
		int i = 0, initX = 250, posY = 0;
		ArrayList vertexes = new ArrayList();
		posY = values.size()*100;
	        this.createVertex(vertexes, name, 80, posY, Color.GRAY, 60, 30);
		
		for (i = 0; i < until; i++)
	        {
			// node "var[index]=value"
		        this.createVertex(vertexes, "<html>Name: " + name + "[" + i + "]" +
							       "<br>Value: " + this.values.get(i) + "</html>", 
						     initX, initY, Color.GREEN, 80, 40);
		        this.createRelation(vertexes, 0, vertexes.size()-1);
		   	initY += 100;
	    	}
		return vertexes;
	}
	
	private void createVertex(ArrayList vertexes, String label, int positionX, int positionY, Color c,
			int width, int height)
    	{
		DefaultGraphCell cell;

    	    	cell  = this.graph.createRectangle(label, positionX, positionY, 
			    		       width, height, c, false);
   	    	cell.addPort();
	    	vertexes.add(cell);
    	}

    	public ArrayList createRelation(ArrayList vertexes, int parent, int child)
    	{
		DefaultEdge edge = new DefaultEdge();
	   	edge.setSource(((DefaultGraphCell)vertexes.get(parent)).getChildAt(0));
	    	edge.setTarget(((DefaultGraphCell)vertexes.get(child)).getChildAt(0));
	    	vertexes.add(edge);
	    	return vertexes;
    	}

  	public void actionPerformed(ActionEvent e) 
	{
		setVisible(false); 
		dispose(); 
	}
}
 

