package Alma;
import Alma.animation.Animate;
import Alma.animation.DrawingPanel;
import  Lisa.Parser.CTreeNode;
import  Lisa.Parser.CSyntaxTree;
import  Lisa.Interface.Component.SyntaxTree.CSyntaxTreeSetup;

import  java.awt.Color;
import  java.awt.Point;


import  java.util.Hashtable;
import  java.util.ArrayList;

import  javax.swing.JFrame;
import  javax.swing.JOptionPane;


import org.jgraph.graph.DefaultGraphCell;

public  class  Backend extends JFrame{
        private TAB tab;
        private TAB tabF;
	private Steps stepsT;
	private Graph graph;
	private CParentNode parent, copy;
	private int pos;
	private Rewrite rew;
	private Visualize vis;
	private Motor motor;
	private boolean animateArgs, allExecuted;
	private Hashtable tableTypes;
	private String fileName;
    //atribute for the animation
    private Animate anim;
    private JFrame frame;

	
	public Backend()
	{
		    // create identifiers table
		    tab          = new TAB();
		    tabF         = new TAB();

		    // save the nodes that will be rewritten
		    this.stepsT           = new Steps();
		    this.motor            = new Motor();
		    this.graph		  = new Graph();
		    this.animateArgs      = false;
		    this.allExecuted      = false;
		    this.rew              = new Rewrite();
		    this.vis              = new Visualize(this.graph);
		    this.pos              = 30;
		    this.tableTypes	  = new Hashtable();
	}


    public void setAnimationPanel(DrawingPanel animationPanel) {
       this.anim = new Animate(tab, animationPanel, this.rew);
    }

    public void setFrame(JFrame jf){
        this.frame = jf;
        this.rew.setFrame(jf);
    }



	public TAB getTAB()
	{
		return this.tab;
	}

	public void setTableTypes(Hashtable t) {
		this.tableTypes = t;
	}

	public Hashtable getTableTypes() {
		return this.tableTypes;
	}

	/** 
	 * this method changes the original tree,
	 * deleting the "DECL" nodes
	 *
	 * so, in case of a DECL node
	 * have the 2 childs (struct and assign)
	 * with null values this subtree will not be 
	 * used to visualize
	 *
	 * otherwise, in case of have the assign child
	 * not equals to "null" we use this assign child
	 *
	 * @root	-- the root of the tree
	 * @return 
	 *
	 * **/
	public CTreeNode setDeclNodes(CTreeNode root)
	{
		int i;
		CTreeNode[] children = root.getNodes();
		String name;

		for (i = 0; i < children.length; i++)
		{
			if (children[i]!=null)
			{
				name = children[i].getSymbol().getName();
				if (name.equals("DECL"))
				{
					if (!children[i].getNodeAt(1).getSymbol().getName().equals("null"))
					{
						children[i] = children[i].getNodeAt(1);
						setDeclNodes(children[i]);
					}
					else	{	root.removeNodeAt(i);	}
				}
				else {	setDeclNodes(children[i]);	}
			}
		}
	
		return root;
	}

	/** 
	 * this method changes the tree result from the method ,
	 * setDeclNodes
	 *
	 * this method will remove all nodes of type
	 * statements that do not have any child
	 *
	 * 		statements -- statements 
	 * 	      /
	 *	     /
	 * statements
	 *
	 * @root	-- the root of the tree
	 * @return 
	 *
	 * **/
	public void hideStmtNodes(CParentNode t)
	{
		int i;
	
		if (t!=null) {
			CTreeNode children = (CTreeNode)t.getLabel();
			String name = children.getSymbol().getName();
			CTreeNode aux = null;

			if (name.equals("STATS")) {
							System.out.println("AQUI2 " + t.getLabel());
				if (t.haveChild()) {
					if (!t.getChild().getHiden()) {
							System.out.println("AQUI " + t.getChild().getLabel());
						hideStmtNodes(t.getChild());
					}
					else if (!t.haveChildSibling()) {
						t.setHidenSubtree(true);
							System.out.println("AQUI " + t.getLabel());
						hideStmtNodes(t.getParent());		
					}
					else if (t.haveChildSibling()) {
						if (!t.getChild().getSibling().getHiden()) {
							hideStmtNodes(t.getChild().getSibling());
						}
					}
				}
				else {
					t.setHidenSubtree(true);
					hideStmtNodes(t.getParent());
				}
			}
			else {
				hideStmtNodes(t.getChild());	
			}
		}
	}

	/** this method hide the definition of functions that appear in 
	 * the tree **/
	public void hideFuncNodes(CParentNode t)
	{
		CTreeNode node;
		String name;

		if (t != null)
		{
			node = (CTreeNode)t.getLabel();
			name = node.getSymbol().getName();

			if (name.equals("FUNC")) {
				t.setHidenSubtree(true);
			}
			else {
				hideFuncNodes(t.getChild());
				hideFuncNodes(t.getSibling());				
			}
		}
	}	

	/** 
	 * this method add to the tree a call method to set the entry point 
	 * of the whole program
	 *
	 * @root	-- the root of the tree
	 * @return 
	 *
	 * **/
	public CTreeNode addCallNode(CTreeNode root)
	{
		CAlmaNode n = new CCallNode("main",null);
		root.addNode(n);
		return root;
	}	

	/** first step in animation:
	 * 1. gets the identifier table;
	 * 2. creates a representation of the tree with CParentNode
	 * 3. creates the first graph
	 *
     * @param btree
     * @param local
     * @param tabArgs
     * @param types
     * @param animatingArgs
     * @param tabFunc
     * @param fileName
     * @param title
     */
	public void firstStep(CSyntaxTree btree,  boolean local, TAB tabArgs, Hashtable types, 
			boolean animatingArgs,
			TAB tabFunc,
			String fileName,
			String title)
	{
		TAB res = new TAB(), aux = new TAB();
		int i, before = -1, next = -1;
		CTreeNode node, rewritten = null, n;
		int confirm = 0;

		this.animateArgs = animatingArgs;
		this.tabF	 = tabFunc;
		this.fileName	 = fileName;

		if (btree != null) {
		    node =  btree.getRoot();
            //btree.print();
		    
		   if (!local)    {
		    	// 1. create identifiers table for node
			CRoot root      = (CRoot)btree;
			this.tab.setIsByCopy(root.getIsByCopy());
			this.tab.collectIdent(node,0,res);
			this.tab        = res;
			node            = setDeclNodes(node);
			this.tableTypes = root.getTableTypes();
			this.rew.setTypes(root.getTableTypes());
			this.rew.setIsByCopy(root.getIsByCopy());
			System.out.println(root.getTableTypes());
		    }
		    else { 
			    this.tab = tabArgs; 
			    this.tableTypes = types;
			    this.rew.setTypes(types);
			    //System.out.println("BACKEND: " + types);
		    }

		    this.rew.setFileName(fileName);
		    this.rew.setTAB(this.tab);

		    //if (nextOne == null)    {
		    if (!local) {
			    if (this.tab.haveEntryPoint("main")) {
				confirm = JOptionPane.showConfirmDialog(null,"Is the function 'main' the entry point?","Main",JOptionPane.YES_NO_OPTION);
				if (confirm == JOptionPane.YES_OPTION) { 
					node = addCallNode(node);
				}
			    }
			    else {
				JOptionPane.showConfirmDialog(null,"Do you want to choose one entry point?","Main",JOptionPane.YES_NO_OPTION);
			    }
		    }

		    // create graphs informations
		    createGraph(node);
		    vis.setTAB(this.tab);
		    vis.setTypes(this.tableTypes);
		    vis.createVertex(parent,local,title);
		    //print(parent);
		    
		    nextOne  = null;
		    row      = -1;
		    position = new Point();
		    postorder(parent);

		    ArrayList table1 = new ArrayList();

		    if (animateArgs && parent.Evaluated()) {
			table1	= tabF.getEnv();
		    }
		    else {
			if (animateArgs) {
		    		next    = getEvaluatedOrToEvaluate(this.tab, nextOne, true);
			}
			else {
		    		next    = getEvaluatedOrToEvaluate(this.tab, nextOne, false);
			}
			table1	= this.tab.getEnv();
		    }

		    //System.out.println(nextOne);
		    if (nextOne!=null) {
			    vis.changeColorCell(parent,nextOne.toString(),Color.RED);		
			    stepsT.addStep(new Table(table1,-1,next,row,position,nextOne,((CParentNode)parent.clone())));
		    }
	    }
	}

	/** make a step forward in animation:
	 * 1. gets the identifier table;
	 * 2. creates a representation of the tree with CParentNode
	 * 3. gets the graph
	 *
	 *     
	 *  */
	public void forwardStep()
	{
		CTreeNode rewritten = null, nextNode = null, lastNode = null;
		int before = -1, next = -1;

		if (!parent.Evaluated())
		{
			TAB aux = (TAB)rew.getTAB().clone();
		        //rewritten = rew.nextNodeToRewrite(copy);
			rew.setRewritten();
			rew.newrewrite(parent,false);	
			//print(parent);
		        //System.out.println("Reescrito: " + rew.getRewritten());
			//getNextNodeToRewrite(parent);
			nextOne  = null;
			row      = -1;
			position = new Point();
			postorder(parent);
			//System.out.println("Proximo: " + nextOne);
			//nextOne=null;
			lastNode  = this.stepsT.getLast().getNode();

			//which line will be colored with green
			before    = this.stepsT.getLast().getNext();

			//which line will be colored with red
		         ArrayList res = new ArrayList();

		    	if (animateArgs && parent.Evaluated()) {
		    		before  = getEvaluatedOrToEvaluate(tabF, lastNode,false);
				res	= tabF.getEnv();
			}
			else {
				if (animateArgs) {
		    			next    = getEvaluatedOrToEvaluate(this.tab, nextOne, true);
				}
				else {
		    			next    = getEvaluatedOrToEvaluate(this.tab, nextOne, false);
				}
				res	= this.tab.getEnv();
			}

		
			//which node will be colored with green
			if (nextOne != null){
                //System.out.println(this.nextOne.getClass().toString());
                //System.out.println(this.parent.getClass().toString());
                vis.changeColorCell(parent,nextOne.toString(),Color.RED);
            }

			// visualization step
			if (lastNode != null) 	{	evaluateNode(parent,lastNode.toString());	}
		    	if (nextOne != null)
				stepsT.addStep(new Table(res,before,next,row,position,nextOne,((CParentNode)parent.clone())));
			else { 
				stepsT.addStep(new Table(res,before,next,row,position,lastNode,((CParentNode)parent.clone())));
			}
			if (lastNode == null && nextOne == null) {
				this.allExecuted = true;
			}

            /**************************************
             **ANIMATION OF THE PROBLEM DOMAIN...**
             **************************************/

            //System.out.println("BACKEND ANIM START");
            //tab.print();
            this.anim.setIdT((TAB)this.tab.clone());
            this.anim.performAnimation(parent);
            //this.anim.printSubTree(parent);
            //System.out.println("BACKEND ANIM END\n--------------------");
		}
		else
		{
			this.allExecuted = true;
			//System.out.println("Over");
		}
	}


	/****************************************************
	 *
	 * get steps of visualization/rewrite
	 *
	 * **************************************************/

	public Steps getAnimationSteps()
	{
		return stepsT;
	}

	/****************************************************
	 *
	 * returns if all nodes are executed
	 *
	 * **************************************************/

	public boolean getAllExecuted()
	{
		return this.allExecuted;
	}


	
	
 /** 
   *  evaluateNode is responsable by change the state of a vertice.
   *  If a node has been evaluated then its state must be
   *  changed to hiden and so its children too.
   *
   *  parameters:
   *  @t     the node to analyse
   *  @node 
   * 
   *  update the nodes that were evaluated also in color
   * */

	private void evaluateNode(CParentNode t, String node)
	{
		String label;
		CTreeNode n, n2;
		CAlmaNode nodeAlma1, nodeAlma2;
		String name, value, type, typeTable;
		Point pos;
		DefaultGraphCell cell;
		int width, height;
		
		//try
		//{
			if (t != null)
			{
				// in case of ASSIGN then the node that will
				// be evaluated is the var (that was assigned)
				// in case of OPER/OPERREL is the own node that
				// is evaluated
				if (t.getLabel().toString().equals(node))
				{
					n          = (CTreeNode)t.getLabel();
					name       = n.getSymbol().getName();
	
					// change state of nodes 
					// --- meaning that they are already evaluated
					t.setHidenSubtree(true);

					// change child
					if (t.getChild()!=null)
					{
						t.getChild().setHidenSubtree(true);
						// change sibling
						if (t.getChild().getSibling()!=null)
						{
							t.getChild().getSibling().setHidenSubtree(true);
						}
					}

					if (name.equals("RETURN"))
					{
						cell = (DefaultGraphCell)(t.getVertice().clone());
						cell.addPort();
						t.setVertice(cell);
						label = ""; 
					
						// in case of "return expr;"
						if (t.getChild()!= null) {
							pos    	   = t.getChild().getPosition();
							
							CParentNode auxT = t.getChild();
							boolean find     = false;

							while (auxT!=null && !find) {
								if (auxT != null) {
									if (auxT.getValue()!=null) {
										find = true;
										n          = (CTreeNode)auxT.getLabel();
										label      = auxT.getValue().toString();
									}
									else { auxT = auxT.getChild(); }
								}
							}
						
						}
						else { 
							pos    	   = t.getPosition();
						}
						t.setVertice(graph.createRectangle("Return: " + label,pos.x,pos.y,45,20,Color.GREEN,false));
					}

					else if (name.equals("ASSIGN"))
					{
						n	   = (CAlmaNode)t.getChild().getLabel();
						nodeAlma1  = (CAlmaNode)t.getChild().getLabel();
						nodeAlma2  = (CAlmaNode)t.getLabel();
				     	        label      = getLabel(t.getChild().getSibling(),n);
						pos        = t.getChild().getPosition();
						width      = t.getChild().getWidth();
						height     = t.getChild().getHeight();
					
						if (nodeAlma2.getType().equals("ARRAY_OR_STRUCT"))
						{
							name       = nodeAlma1.getName();
							type       = this.tab.getType(name);
							typeTable  = (this.tableTypes.containsKey(type)) ? 
									((String)this.tableTypes.get(type)) : type;

							if (typeTable.equals("array"))
							{
								value = motor.getCorrectValue(t.getChild().getSibling()).toString();
								ArrayList values = new ArrayList();
								Object tempO = this.tab.getTable(name);
								if (tempO != null) { values = (ArrayList)tempO; }
							        else { values = new ArrayList(); }
								int index        = Integer.parseInt(value);
								label = "<html>Name: " + 
								       name + "[" + value + "]" +
									"<br>Value: " + 
									(values.size() > index ? 
									 values.get(index).toString() : 
									 "") + "</html>";
							}
							else if (this.tab.getType(nodeAlma1.getName()).equals("struct"))
							{
								Object[] attrs = ((CTreeNode)t.getLabel()).getAttributes();
								label = "<html>Name: " + 
									attrs[0] + "." + attrs[3] + 
									"<br>Value: " + this.tab.getLocalValue(attrs[0].toString(),
								       attrs[3].toString()) + "</html>";
							}
						}

						t.getChild().setVertice
							(graph.createRectangle(label,pos.x,pos.y,width,height,Color.GREEN,false));
					}
					else if (name.equals("OPER") || name.equals("OPERREL"))
					{
						pos    = t.getPosition();
						width  = t.getWidth();
						height = t.getHeight();
						
						label      = t.getValue().toString();
					     
					     t.setVertice(graph.createRectangle(label,pos.x,pos.y,width,height,Color.GREEN,false));
					}
					else if (name.equals("READ"))
					{
						pos    = t.getChild().getPosition();
						width  = t.getChild().getWidth();
						height = t.getChild().getHeight();
						n      = (CTreeNode)t.getChild().getLabel();
	
						// we want read node visible
				     	        label  = getLabel(t,n);
						cell = (DefaultGraphCell)(t.getVertice().clone());
						cell.addPort();
						t.setVertice(cell);
						t.getChild().setVertice(graph.createEllipse(label,pos.x,pos.y,width,height,Color.GREEN,false));
					}
					else if (name.equals("CALL"))
					{
						pos            = t.getPosition();
						width          = t.getWidth();
						height         = t.getHeight();
						CAlmaNode auxN = (CAlmaNode)n;
	
						cell = (DefaultGraphCell)(t.getVertice().clone());
						cell.addPort();
						if (t.getValue()!=null) {
							t.setVertice(graph.createRectangle("<html>Call: " + auxN.getName() +
										"<br/>Value: " + t.getValue() + 
										"</html>",pos.x,pos.y,width,height,Color.GREEN,false));
						}
						else {
							t.setVertice(graph.createRectangle(cell.toString(),pos.x,pos.y,width,height,Color.GREEN,false));
						}
					}					
					else if  (name.equals("WRITE"))
					{
						cell = (DefaultGraphCell)(t.getVertice().clone());
						cell.addPort();
						t.setVertice(cell);
					
						pos    	   = t.getChild().getPosition();
						n          = (CTreeNode)t.getChild().getLabel();
						label      = t.getChild().getValue().toString();
						t.getChild().setVertice(graph.createRectangle(label,pos.x,pos.y,45,20,Color.GREEN,false));			
					}
				}
				else
				{
					if (t.getVertice() != null)
					{
						cell = (DefaultGraphCell)(t.getVertice().clone());
						cell.addPort();
						t.setVertice(cell);
						if (t.getChild()!=null) {
							evaluateNode(t.getChild(),node);
						}
						if (t.getSibling() != null)	{
							evaluateNode(t.getSibling(),node);
						}
					}
				}
			}
		//}
		//catch (Exception e)
		//{
		//	JOptionPane.showMessageDialog(null,"Error: " + e.getMessage() + ".");
		//}
		
	}
	
	/** Gets the information about node to color in table 
	 * (represents the node that have been evaluated or 
	 * that will be evaluate)
	 * */
	    private int getEvaluatedOrToEvaluate()
	    {
		    int before = -1;
		    CTreeNode aux;
		    String name;
		    
		    if (rew.getChangedNodes().size() > 0)
		    {
			    aux  = (CTreeNode)rew.getChangedNodes().get(rew.getChangedNodes().size()-1);
			    name = aux.getSymbol().getName();
			    
			    if (name.equals("ASSIGN") || name.equals("READ"))
			    {
				    before = tab.getIndexOfIdent((String)(aux.getNodeAt(0).getAttributes()[0]));
			    }
		    }

		    return before;
	    }

	/** Gets the information about node to color in table 
	 * (represents the node that have been evaluated or 
	 * that will be evaluate)
	 * */
	private int getEvaluatedOrToEvaluate(TAB tab, CTreeNode rewritten, boolean last)
	{
		    int beforeOrNext = -1;
		    CTreeNode aux;
		    CAlmaNode child;
		    String name;
		   
		    if (rewritten != null)
		    {
			    name = rewritten.getSymbol().getName();
				    
			    if (name.equals("ASSIGN") || name.equals("READ"))
			    {
				    if (!rewritten.getAttributes()[2].toString().equals("ARRAY_OR_STRUCT"))
				    {
					    if (last) {
						    beforeOrNext = tab.getLastIndexOfIdent((String)(rewritten.getNodeAt(0).getAttributes()[0]));
					    }
					    else {
						    beforeOrNext = tab.getIndexOfIdent((String)(rewritten.getNodeAt(0).getAttributes()[0]));
					    }
				    }
			    }
		    }

		    return beforeOrNext;
	    }
	    

	/** Gets the position of the first child to 
	 * draw correctly the tree in window
	 * */
	public void getPosition(CParentNode t)
	{	
		if (t != null)
		{
			if (t.getChild() != null)
			{
				pos += (t.getBorder()*4 + t.getHeight() + t.getParentDist() + 20);
				getPosition(t.getChild());
			}
		}
		pos += t.getBorder();
	}
	public void createGraph(CTreeNode node)
	{
    		int root_x;
		CParentNode paintRoot;
		paintRoot = convertTree(node);
		parent    = paintRoot;
		copy      = convertTree(node);
		hideFuncNodes(parent);
		//postorderToHide(parent);
		//hideStmtNodes(parent);
		//print(parent);
		parent.layout(parent);
		
		CSyntaxTreeSetup ssetup;
		ssetup = new CSyntaxTreeSetup();
		parent.setSetup(ssetup);

		parent.calculateTreeDimension();
		root_x = ssetup.rootX;
	        parent.plantTree(parent, 0, 0);
		parent.calculateTreeDimension();
	        parent.plantTree(parent, root_x, ssetup.rootY+50);
	}

	public void print(CParentNode t)
	{
		if (t != null)
		{
			if (!t.getHiden()) 
				System.out.println("__" + t.getLabel() + " " + t.getLevel() + 
						" " + t.getHiden() + " Row,Column: " + t.getRow() + " " + t.getColumn());			
			print(t.getChild());
			print(t.getSibling());
		}
	}

	public void print(CTreeNode t)
	{
		int i = 0;
		CAlmaNode n;
		Object[] attr = new Object[3];

		if (t != null)
		{
			if (!t.getSymbol().getName().equals("null"))
			{
				attr = t.getAttributes();
				System.out.print("--> " + " - " + t  + " - ");
			       if (t.getToken()!=null) {
				       System.out.println(t.getToken().row() + ", " + t.getToken().column() ); //attr[0] + " , " + attr[1] + " , " + attr[2]);
			       }
			       else { System.out.println(); }
				for (i = 0; i < t.getNodes().length; i++) {
					print(t.getNodeAt(i));
				}
			}
			else { System.out.println("--> " + t);	}
		}
	}


	private Object getValueNode(CParentNode t, CTreeNode node)
	{
		Object label = null;

		if (t!=null)
		{
			if (t.getLabel().toString().equals(node.toString()))
			{
				label =  node.getAttributes()[1];
				return label;
			}
			else
			{
				getValueNode(t.getChild(),node);
				getValueNode(t.getSibling(),node);
			}
		}
		return label;
	}

	  CTreeNode nextOne = null;
	  int row = -1;
	  Point position = new Point();

	  // maybe rewrite this: very similar to rewriteStruct in Rewrite.java
	public boolean isStruct(CParentNode subtree)
	{
		String name, nameVar;
		CTreeNode node;
		boolean flag = false;
		
		node = (CTreeNode)subtree.getLabel();
		name = node.getSymbol().getName();

		// first test: is assignment
		// second test: is not an indexation or struct access
		if (name.equals("ASSIGN") && !((CAlmaNode)node).getType().equals("ASSIGN_OR_STRUCT"))
		{
			nameVar = ((CAlmaNode)node.getNodeAt(0)).getName();
			// first test: is a structured data type
			// the second one: to garantee that we are not assigning
			// a value to a variable in a struct
			// the third: is not already evaluated
			if (this.tab.getType(nameVar).equals("struct"))
			{
				if (!(((CTreeNode)subtree.getChild().getLabel()).getAttributes()[2]).toString().equals("ARRAY_OR_STRUCT")
						&&
						!subtree.getChild().getSibling().Evaluated())
				{	
					flag = true;
				}
			}
		}
		return flag;
	}

	  public void postorder(CParentNode tree)
	  {
		  // transform this in a class
	      ArrayList nodesCanRewrite = new ArrayList();
	      nodesCanRewrite.add("READ");
	      nodesCanRewrite.add("WRITE");
	      nodesCanRewrite.add("OPER");
	      nodesCanRewrite.add("OPERREL");
	      nodesCanRewrite.add("CALL");
	      nodesCanRewrite.add("RETURN");
	      nodesCanRewrite.add("ASSIGN");
	      // ----------------------------
	      CTreeNode n;
	      CAlmaNode aux;
	      String name;

		  if (tree!=null)
		  {
			  n    = (CTreeNode)tree.getLabel();
			  name = n.getSymbol().getName();

			  // this test it is only to prevent an
			  // unnecessary traversal to the tree
			  if (!name.equals("FUNC"))
			  {
				  // this test is to not evalute
				  // the arguments of the function
				  if (!name.equals("CALL")) {
				      	// this test is to not enter in the definition of a struct 
					if (!isStruct(tree)) {
						if (tree.getChild() !=null)  {
							postorder(tree.getChild());
							  if(tree.getChild().getSibling()!=null) {
								  postorder(tree.getChild().getSibling());
								  if(tree.getChild().getSibling().getSibling()!=null) {
									  postorder(tree.getChild().getSibling().getSibling());
						  		  }
						  	}
				  		}	
				  	}
				  }
			
				  if (!tree.Evaluated()) {
					  if (!name.equals("null"))	  {
					  	if (nodesCanRewrite.contains(name) && nextOne == null){
							  nextOne  = n;
							  row      = getRowColumn(tree,n);
                              //System.out.println(" nodo: " + n.toString() + "linha: " + row);
							  position = tree.getPosition();
						  }
					  }
				  }
			  }
		  }
	  }

	  public int getRowColumn(CParentNode tree, CTreeNode n) {
		  CTreeNode aux;
		  CParentNode child;
		  boolean found = false;
		  int r = -1;

		  if (tree!=null) {
			  aux = (CTreeNode)tree.getLabel();

			  if (aux.toString().equals(n.toString())) {
				  if (tree.getRow() == -1) {
					child = tree.getChild();	
					while(child!=null && !found) {
						if (child.getRow() == -1) {
							child = child.getChild();
						}
						else {
							r = child.getRow();
							found = true;
						}
					}
				  }
				  else {
					  r = tree.getRow();
				  }
			  }
		  }
		  return r;
	  }

/*	  public Point getPosition(CParentNode tree, CTreeNode n) {
		  CTreeNode aux;
		  CParentNode child;
		  boolean found = false;
		  int r = -1;

		  if (tree!=null) {
			  aux = (CTreeNode)tree.getLabel();

			  if (aux.toString().equals(n.toString())) {
				  child = tree.getChild();	
					while(child!=null && !found) {
						if (child.getRow() == -1) {
							child = child.getChild();
						}
						else {
							r = child.getRow();
							found = true;
						}
					}
				  }
			  }
		  }
		  return r;
	  }*/

	  public void postorderToHide(CParentNode tree)
	  {
	      CTreeNode n;
	      String name;

		  if (tree!=null)
		  {
			  n    = (CTreeNode)tree.getLabel();
			  name = n.getSymbol().getName();

			  if (!tree.getHiden()) {
				  System.out.println("POST: " + n);

				if (tree.haveChild() && !(isHidenChildren(tree)))  {
					postorderToHide(tree.getChild());
				}
				else {
					if (name.equals("STATS")) {
						tree.setHidenSubtree(true);
						postorderToHide(tree.getParent());
				  		System.out.println("POST - to remove: " + n);
					}
				}

				if (tree.haveChildSibling()) {
					postorderToHide(tree.getChild().getSibling());
				}

				if (tree.haveSecondSibling()) {
					  postorderToHide(tree.getChild().getSibling().getSibling());
				}
		  	 }
		   }
	  }


	  public boolean isHidenChildren(CParentNode tree) {
		boolean res = true;
	      	CTreeNode n;
		String name;

		  if (tree!=null)
		  {

			if (tree.haveChild() && tree.getChild().getHiden())  {
	      			n = (CTreeNode)tree.getChild().getLabel();
			        name = n.getSymbol().getName();

				if (!name.equals("STATS") || !name.equals("FUNC")) {
					res = false;
				}
			}

			if (tree.haveChildSibling() && tree.getChild().getSibling().getHiden()) {
	      			n = (CTreeNode)tree.getChild().getSibling().getLabel();
			        name = n.getSymbol().getName();

				if (!name.equals("STATS") || !name.equals("FUNC")) {
					res = false;
				}
			}

			if (tree.haveSecondSibling() && !tree.getChild().getSibling().getSibling().getHiden()) {
	      			n = (CTreeNode)tree.getChild().getSibling().getSibling().getLabel();
			        name = n.getSymbol().getName();

				if (!name.equals("STATS") || !name.equals("FUNC")) {
					res = false;
				}
			}
		   }
		  return res;
	  }

      public String getLabel(CParentNode t, CTreeNode node)
      {
	      String name, res;
	      Object nameVar, label, type, typeTable;
	      Alma.CAlmaNode n;

	      res   = new String();
	      name  = node.getSymbol().getName();
	      n     = (CAlmaNode)node;
	      label = t.getValue();

	      if (name.equals("CONST"))
 	      {
			res = "Constant: " + label;
	      }
	      else if (name.equals("VAR"))
	      {
		      nameVar = n.getName();
		      
		      if (label == null)
		      {
			      res = "<html>Name: " + nameVar + "<br>Value: </html>";
		      }
		      else
		      {
			      res = nameVar + " (Value: " + label + ")";
		      }
	      }
	      else
	      {
		      CTreeNode aux   = (t.getChild() == null) ? 
			      			(CTreeNode)t.getParent().getChild().getLabel() : 
						(CTreeNode)t.getChild().getLabel();
		      Object[] attrs  = new Object[4];
		      attrs           = aux.getAttributes();

		      //System.out.println(aux + " - " + attrs[0] + attrs[1] + " , " + attrs[2]);
		      type            = this.tab.getType(attrs[0].toString());
		      typeTable       = (this.tableTypes.containsKey(type)) ? ((String)this.tableTypes.get(type)) : type;

		      if (attrs.length == 4)
		      {
			      if (typeTable.equals("array"))
			      {
			      		res = "<html>Name: " + attrs[0] + "[" + attrs[3] + "]" +
					      "<br>Value: " + label + "</html>";
			      }
			      else if (typeTable.equals("struct"))
			      {
      			      		res = "<html>Name: " + attrs[0] + "." + attrs[3] + 
					      "<br>Value: " + label + "</html>";
			      }
		      }
		      else { res = "" + label; }
	      }

	      return res;
		     
      }
	/**
	 *
	 * Converts an entire node in a CParentNode
	 * */
	public CParentNode convertTree(CTreeNode node) 
	{
		CParentNode t = makeNode(null, null, null, null);

		if (node!=null) {
			t=makeNode(node,null,null,null);
			convertNode(t, node);
		}

		return t;
	}
   
   
 /**
  * Create a new node with the child and siblings.
  */
  private CParentNode makeNode(CTreeNode node, CParentNode p, CParentNode c, CParentNode s) {
	  CParentNode a = null;
	  
	  if (node != null)  {
		  a       = new CParentNode(node, p, c, s, false, null);
	  }
	  
	  return a;
  }

  /**
   * converts a node of type CTreeNode in a node of type CParentNode.
   * CParentNode saves information about the child of a node and siblings
   * of this child.
   * */
 private void convertNode(CParentNode t, CTreeNode node) {
	  int i;
	  CParentNode s;
	  
	  if (t != null)
	  {
		  if (node != null) {
			  if (node.size()>0)  {
				  t.setChild(makeNode(node.getNodeAt(0),t,null,null)); 
				  s = t.getChild();
				  convertNode(s, node.getNodeAt(0));

				  if (node.size()>1)  {
				 	for (i=1; i<node.size(); i++) {
						if (s!=null) {
						  s.setSibling(makeNode(node.getNodeAt(i),t,null,null)); 
						  convertNode(s.getSibling(), node.getNodeAt(i));
					  	  s=s.getSibling();
						}
					}
				  }
			  }
		  }
	  }
  }


}
     
       
