package Alma;

import Alma.animation.Actor;
import Alma.animation.DrawingPanel;
import  Lisa.Parser.CTreeNode;
import  Lisa.Parser.CSyntaxTree;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.Point;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.Toolkit;

import java.io.File;
import java.util.ArrayList;
import java.util.Hashtable;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JSplitPane;
import javax.swing.JScrollPane;
import javax.swing.JOptionPane;
import javax.swing.JTextPane;



public class FuncDialog extends JDialog implements ActionListener {

	private TAB tab;
	private Backend backendA, backendF;
	private TableDesign table;
	private JSplitPane vertical;	
	private JTextPane editorPane;
	private JButton back, forward, reset, skip, zoomM, zoomL;
	private Steps stepsA, stepsF, stepsT;
	private Motor motor;
	private ArrayList vertices;
	private Graph graphA, graphF, graph;	
	private double zoom;
	// to return the value in case of return
	private Object value;
	// variable to detect if we are press buttons in
	// first step or in second
	private boolean fst;
	private boolean change;
	// variable do detect if steps were executed
	private TabbedPane right;
	// a tree to know where node is located	
	private CParentNode tree;
	// the name of the source program
	private String fileName;
    private DrawingPanel animPanel;
    
  public FuncDialog(JFrame parent, 
		  Hashtable types,
		  ArrayList args,
		  ArrayList loc,
		  CParentNode tree1,
		  CTreeNode funcN,
		  String nameFunc,
		  String fileName1,
          DrawingPanel animPanel
			) 
  {
	super(parent,"Function call: " + nameFunc,true);
        Dimension d        = Toolkit.getDefaultToolkit().getScreenSize();	
	/** local variables **/
	Table aux;

    this.animPanel = animPanel;
	this.table         = new TableDesign();
	this.tab	   = new TAB();
	this.backendA      = new Backend();
	this.backendF      = new Backend();
	this.stepsA        = new Steps();
	this.stepsF        = new Steps();
	this.stepsT        = new Steps();
	this.motor         = new Motor();
	this.zoom          = 1.0;
	//this.skip          = new JButton("Skip"); 
	this.reset 	   = new JButton("Reset");
	this.back 	   = new JButton("Back");
	this.forward 	   = new JButton("Forward");
	this.zoomM 	   = new JButton("Zoom +");
	this.zoomL 	   = new JButton("Zoom -");
	this.vertices      = new ArrayList();
	this.graphA        = new Graph();
	this.graphF        = new Graph();
	this.graph         = new Graph();
	this.fst           = false;
	this.change        = false;
	this.tree          = tree1;
	this.fileName	   = fileName1;
	this.editorPane    = new JTextPane();
	boolean haveArgs   = false;
    
    this.backendA.setAnimationPanel(this.animPanel);
    this.backendF.setAnimationPanel(this.animPanel);
	
	right   = new TabbedPane(graphA.getGraph(),graphF.getGraph());
	
	this.table.setTypes(types);

	ReadFile readFile      = new ReadFile();
	File testFile          = new File(this.fileName);

	this.editorPane.setEditorKit(new NumberedEditorKit());
	this.editorPane.setText(readFile.getContents(testFile));
	this.editorPane.setEditable(false);
	JScrollPane editor = new JScrollPane(this.editorPane);
	editor.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
	editor.setPreferredSize(new Dimension(250, 445));
	editor.setMinimumSize(new Dimension(10, 10));

	if (funcN != null)
	{
		CSyntaxTree cs = new CSyntaxTree();
		String name;

		/** Arguments **/
		if (funcN.getNodeAt(0) != null)
		{
			name = funcN.getNodeAt(0).getSymbol().getName();
			
			if (!name.equals("null")) {
				// inherits the identifier's table from the local where
				// the function is called
				this.tab       = new TAB(args);
				cs.setRoot(funcN.getNodeAt(0));
				this.backendA.firstStep(cs,true, this.tab, types, true, new TAB(loc), fileName1,"Arguments");
				// change the animations steps obtained by backend.animate
				this.stepsA = backendA.getAnimationSteps();
				haveArgs    = true;
			}
			else { fst = false; }
		}

		/** Function **/
		if (funcN.getNodeAt(1) != null)
		{
			name = funcN.getNodeAt(1).getSymbol().getName();
			
			if (!name.equals("null")) {
				cs.setRoot(funcN.getNodeAt(1));
				this.tab 	= new TAB(loc);
				this.backendF.firstStep(cs,true,this.tab, types, false,null,fileName1,"Function"); 
				// change the animations steps obtained by backend.animate
				this.stepsF = backendF.getAnimationSteps();
			}
		}
	}

	// the table
	if (stepsA.getSteps()!= null)
	{
		if (stepsA.getSteps().size() > 0)
		{
			aux         = ((Table)stepsA.getSteps().get(0));

			// view this method (should be changed/optimized)
			table.createTable2(aux.getTable(),aux.getBefore(),aux.getNext());

			if (aux.getRow() != -1) {
				motor.highlightPanel(editorPane,aux.getRow());
			}
			// the graph
			this.right.getComponentAt(0).getViewport().setViewPosition(aux.getPosition());
			motor.makeGraph(aux.getAll(),vertices);
			graphA.setGraph(vertices);

			fst = true;
		}
	}

	// the second pane
	if (stepsF.getSteps()!= null)
	{
		if (stepsF.getSteps().size() > 0)
		{
			aux         = ((Table)stepsF.getSteps().get(0));

			if (!haveArgs) { 
				// view this method (should be changed/optimized)
				table.createTable2(aux.getTable(),aux.getBefore(),aux.getNext());
				if (aux.getRow() != -1) {
					motor.highlightPanel(editorPane,aux.getRow());
				}
				this.right.getComponentAt(1).getViewport().setViewPosition(aux.getPosition());
				//System.out.println(aux.getPosition() + " , " + right.getComponentAt(1).getViewport().getViewSize());
			}
		
			// the graph
			motor.makeGraph(aux.getAll(),vertices);
			graphF.setGraph(vertices);
		}
	}

	
	/************************************
	 * first steps is what we want to 
	 * visualize
	 * **********************************/


	if (!fst) { right.enableSndPane();	}

	
	

	/******************************************
	 * Skip button
	 * ***************************************/
	/*this.skip.addActionListener(new java.awt.event.ActionListener() {
         	public void actionPerformed(java.awt.event.ActionEvent e) {
		skipStepByStep();
	}
	});*/
		
	/******************************************
	 * Reset button
	 * ***************************************/

	reset.setEnabled(false);

	reset.addActionListener(new java.awt.event.ActionListener() {
	public void actionPerformed(ActionEvent e) {
		back.setEnabled(false);
		forward.setEnabled(true);

		if (fst)	{ stepsT = stepsA; graph = graphA; }		
		else		{ stepsT = stepsF; graph = graphF; }
		stepsT.setPosition(0);

		Table aux   = ((Table)stepsT.getSteps().get(0));
		motor.makeGraph(aux.getAll(),vertices);
		graph.setGraph(vertices);
		table.setCellColor(aux.getBefore(),aux.getNext());
       	}
       	});

	/******************************************
	 * Backward button
	 * ***************************************/

	back.setEnabled(false);

	back.addActionListener(new java.awt.event.ActionListener() {
        public void actionPerformed(java.awt.event.ActionEvent e) {		
		// identifier table
		Table aux; 
		ArrayList ids;

		forward.setEnabled(true);
		if (fst)	{ stepsT = stepsA; graph = graphA; }		
		else		{ stepsT = stepsF; graph = graphF; }

		// graphA
		if (stepsT.getPosition() != 0)
		{  
			aux = stepsT.getBackStep();
			ids    = aux.getTable();

			if (ids.size() != 0) { 
			}
				table.setCellColor(aux.getBefore(),aux.getNext());
				
				motor.makeGraph(aux.getAll(),vertices);
				graph.setGraph(vertices);
			}
			else 	{	back.setEnabled(false);	}
          	}
        	});

	/*****************************************
	* Forward button
	* ***************************************/

	forward.addActionListener(new java.awt.event.ActionListener() {
        public void actionPerformed(java.awt.event.ActionEvent e) {
		if (fst)
		{   
			if (stepsA.getSteps().size()>0) {
				backendA.forwardStep();
				Table t = backendA.getAnimationSteps().getLast();
				if (t.getAll().Evaluated()) {
					fst = false;
					right.enableSndPane();
				}
				
				ArrayList ids = new ArrayList();
				
				// change graph
				vertices.clear();
				motor.makeGraph(t.getAll(),vertices);
				graphA.setGraph(vertices);

                
				if (t.getRow() != -1) {
					motor.highlightPanel(editorPane,t.getRow());
                    //System.out.println("ROW FW: " + t.getRow());
				}

				right.getComponentAt(0).getViewport().setViewPosition(t.getPosition());

				// change identifiers table
				ids = t.getTable();
				if (ids.size() != 0) { 
					table.setTable(ids); 
					table.setCellColor(t.getBefore(),t.getNext());
				}	
			}
		}
		else {
			if (stepsF.getSteps().size()>0) {
				backendF.forwardStep();
	
				Table t = backendF.getAnimationSteps().getLast();
				if (backendF.getAllExecuted()) {
							setVisible(false); 
                            dispose();
				}
				else {
					if (t.getNode() != null) {
						if (t.getNode().getSymbol().getName().equals("RETURN"))	{
							motor.setValue();
							motor.findNode(t.getAll(),t.getNode());
							value 	     = motor.getValue();
						}
					}
				}				

				ArrayList ids = new ArrayList();
				
				if (t.getRow() != -1) {
					motor.highlightPanel(editorPane,t.getRow());
					//System.out.println("ROW Func: " + t.getRow());
				}
	
				Point p = new Point(t.getPosition().x-40,t.getPosition().y-40);

				right.getComponentAt(1).getViewport().setViewPosition(p);

				// change graph
				vertices.clear();
				motor.makeGraph(t.getAll(),vertices);
				graphF.setGraph(vertices);

				// change identifiers table
				ids = t.getTable();
				if (ids.size() != 0) { 
					//System.out.println(ids);
					table.setTable(ids); 
					table.setCellColor(t.getBefore(),t.getNext());
				}	
			}
		}
	}	
      });

	/*****************************************
	* Zoom + button
	* ***************************************/

	zoomM.addActionListener(new java.awt.event.ActionListener() {
        public void actionPerformed(java.awt.event.ActionEvent e) {
		zoom += 0.1;
		if (fst)	{ graphA.getGraph().setScale(zoom); }		
		else		{ graphF.getGraph().setScale(zoom); }		
        }
        });

	/*****************************************
	 * Zoom - button
	 * ***************************************/

	zoomL.addActionListener(new java.awt.event.ActionListener() {
       	public void actionPerformed(java.awt.event.ActionEvent e) {
		if (zoom != 0.1)
		{
			zoom -= 0.1;
			if (fst)	{ graphA.getGraph().setScale(zoom); }		
			else		{ graphF.getGraph().setScale(zoom); }		
		}
		else
		{
			JOptionPane.showMessageDialog(null,"Zoom out of ranges!",
							    "Alma information",
							    JOptionPane.INFORMATION_MESSAGE);
		}
         }
       	});



    /**************************************
     * DEFINING LAYOUT
     *************************************/

    JPanel panel           = new JPanel(new BorderLayout());
	JPanel left            = new JPanel(new BorderLayout());
	JPanel panelTable      = new JPanel(new BorderLayout());
	JPanel panelButton     = new JPanel();

	JScrollPane p, pEditor;
	JSplitPane horizontal;

    p = new JScrollPane(table.getTable());
	p.setPreferredSize(new Dimension(150,180));
	panelTable.add(new JLabel("Identifiers",JLabel.CENTER),BorderLayout.NORTH);
	panelTable.add(editor, BorderLayout.SOUTH);
	panelTable.add(p,BorderLayout.CENTER);
	left.add(panelTable, BorderLayout.NORTH);
    

	//panelButton.add(reset);
	//panelButton.add(back);
    panelButton.add(zoomL);
    panelButton.add(forward);
    panelButton.add(zoomM);

    left.add(panelButton, BorderLayout.SOUTH);

    JPanel p1 = new JPanel(new BorderLayout());
    JSplitPane pright = new JSplitPane(JSplitPane.VERTICAL_SPLIT, right, this.animPanel);
    pright.setDividerLocation(400);

	//panelButton.add(skip);
	//panel.add(panelButton,BorderLayout.CENTER);
	horizontal = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT, left, pright);
	horizontal.setDividerLocation(300);

    p1.add(horizontal);
	this.getContentPane().add(p1);

	this.setSize((int)d.getWidth()-100,(int)d.getHeight()-100); 
	this.setLocationRelativeTo(null);
	//horizontal.setDividerLocation((int)(d.getWidth()/3));
	//vertical.setDividerLocation((int)d.getWidth()/2-20);


    //ACTION BEFORE CLOSING/DISPOSING THIS WONDOW
    //System.out.println(this.getClass(.toString());

      try {
          this.addWindowListener(new CloseDialogListener((AnimateFrame) this.getParent(), this.animPanel.getActors()));
      } catch (Exception e) {
        
      }

	setVisible(true);

  }
  
   	public void skipStepByStep()
	{
	}

  	public void actionPerformed(ActionEvent e)
	{
	//	System.out.println("Fechou?");
	//	setVisible(false);
	//	dispose();
  	}

	public Object getValue()
	{
		return this.value;
	}
}
 

