/************************************************
 *
 * @author Daniela da Cruz
 * @version 2.0, September 2006 
 *
 * This class is the first frame that appears
 * in Alma System
 *
 ************************************************/

package Alma;

import  Lisa.Parser.CTreeNode;
import  Lisa.Parser.CSyntaxTree;

import  javax.swing.JFrame;
import  javax.swing.JPanel;
import  javax.swing.JButton;
import  javax.swing.JLabel;
import  javax.swing.ImageIcon;
import  javax.swing.JFileChooser;

import  java.awt.Toolkit;
import  java.awt.Color;
import  java.awt.Dimension;
import  java.awt.BorderLayout;
import  java.awt.event.ActionEvent;

public class MainFrame extends JFrame
{
	private AnimateFrame second;
	private CSyntaxTree root;
	
	public MainFrame()
	{
		this.second         = new AnimateFrame();
		Dimension d         = Toolkit.getDefaultToolkit().getScreenSize();
		JPanel panel1       = new JPanel();
		JPanel panel2       = new JPanel();
		JPanel panel3       = new JPanel(new BorderLayout());
		JButton chooseFile  = new JButton("Choose file");
		JButton defaultFile = new JButton("Default files");
		
		/******************************************
		 * choose file button
		 * ***************************************/

		defaultFile.addActionListener(new java.awt.event.ActionListener() 
		{
			public void actionPerformed(java.awt.event.ActionEvent e) 
			{
				setVisible(false);
				second.setRoot(root);
				second.createBackend();
				second.initComponents();
				second.setVisible();
			}
        	});
		
		chooseFile.addActionListener(new java.awt.event.ActionListener() 
		{
			public void actionPerformed(java.awt.event.ActionEvent e) 
			{
				JFileChooser chooser = new JFileChooser();
				ExampleFileFilter filter = new ExampleFileFilter();
				filter.addExtension("lisa");
				filter.setDescription("LISA source files");
				chooser.setFileFilter(filter);
				int returnVal = chooser.showOpenDialog(null);
				if(returnVal == JFileChooser.APPROVE_OPTION) {
					//System.out.println("You chose to open this file: " +
					//chooser.getSelectedFile().getName());
    				}
			}
        	});
		JLabel image  = new JLabel(new ImageIcon("logoAlma4.png"));
		panel1.add(image);
		panel2.setBackground(Color.WHITE);
		panel2.add(chooseFile);
		panel2.add(defaultFile);
		
		panel3.add(panel1,BorderLayout.CENTER);
		panel3.add(panel2,BorderLayout.SOUTH);
		
		setTitle("Alma System");
		getContentPane().add(panel3);
		setLocation((int)d.getWidth()/2-200,(int)d.getHeight()/2-200);
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);		
		pack();
		setResizable(false);
		setVisible(true);
	}

	public void setRoot(CSyntaxTree root)
	{
		this.root = root;
	}
}
