package Alma;

/*
 * TabbedPane.java requires one additional file:  images/middle.gif.
 */

import javax.swing.JTabbedPane;
import javax.swing.JScrollPane;
import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JFrame;
import javax.swing.JComponent;
import javax.swing.SwingUtilities;
import javax.swing.UIManager;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.GridLayout;
import java.awt.event.KeyEvent;
import java.awt.Component;

import org.jgraph.JGraph;

public class TabbedPane extends JPanel {
	private JTabbedPane tabbedPane;

    public TabbedPane(JGraph graphA,JGraph graphF) {
        super(new GridLayout(1, 1));
        
        tabbedPane = new JTabbedPane();
        ImageIcon icon = createImageIcon("Images/default.png");
        
        tabbedPane.addTab("Passing arguments", icon, new JScrollPane(graphA),
                "Passing arguments to the function");
        tabbedPane.setMnemonicAt(0, KeyEvent.VK_1);
        
        JComponent panel2 = makeTextPanel("Panel #2");
        tabbedPane.addTab("Executing function", icon, new JScrollPane(graphF),
                "Executing the function");
        tabbedPane.setMnemonicAt(1, KeyEvent.VK_2);

	tabbedPane.setEnabledAt(1,false);

        //Add the tabbed pane to this panel.
        add(tabbedPane);
        
        //The following line enables to use scrolling tabs.
        tabbedPane.setTabLayoutPolicy(JTabbedPane.SCROLL_TAB_LAYOUT);
    }
   

    public JScrollPane getComponentAt(int i) {
	    return (JScrollPane)this.tabbedPane.getComponentAt(i);
    }

    public void enableSndPane()
    {
	tabbedPane.setEnabledAt(1,true);
	tabbedPane.setSelectedIndex(1);
    }

    public void disableFstPane()
    {
	tabbedPane.setEnabledAt(0,false);
    }

    protected JComponent makeTextPanel(String text) {
        JPanel panel = new JPanel(false);
        JLabel filler = new JLabel(text);
        filler.setHorizontalAlignment(JLabel.CENTER);
        panel.setLayout(new GridLayout(1, 1));
        panel.add(filler);
        return panel;
    }
    
    /** Returns an ImageIcon, or null if the path was invalid. */
    protected static ImageIcon createImageIcon(String path) {
        java.net.URL imgURL = TabbedPane.class.getResource(path);
        if (imgURL != null) {
            return new ImageIcon(imgURL);
        } else {
            System.err.println("Couldn't find file: " + path);
            return null;
        }
    }
    
}
