/** This class is to draw the table for
 *  arrays initialization
 *
 *  @author Daniela da Cruz, danieladacruz@di.uminho.pt
 *  @version 11 October, 2006 (first version)
 *
 *  */

package Alma;

import javax.swing.JFrame;
import javax.swing.JButton;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JPanel;
import javax.swing.JSplitPane;
import javax.swing.JLabel;

import java.awt.Color;
import java.awt.BorderLayout;
import java.awt.Dimension;

import org.jgraph.graph.DefaultGraphCell;
import org.jgraph.graph.DefaultEdge;

import java.util.ArrayList;

public class TableArray extends JFrame
{
	private Graph graph;
	private ArrayList graphs, values, ids, tableIdent;
	private TableDesign tableDesign;
	private JButton back, forward, reset, zoomM, zoomL;			
	private int row, initY, toBack, toFront, position, before, next;
	private double zoom;
	private String name;

	public TableArray()
	{
		this.graph       = new Graph();
		this.graphs	 = new ArrayList();
		this.ids	 = new ArrayList();
		this.tableDesign = new TableDesign();
		this.tableIdent  = new ArrayList();
		this.name	 = new String();
		this.position    = 0;
		this.zoom	 = 1.0;
		this.back        = new JButton("Back");
		this.back.addActionListener(new java.awt.event.ActionListener() {
          	public void actionPerformed(java.awt.event.ActionEvent e) {		
			ArrayList vertexes = new ArrayList();
			ArrayList idents   = new ArrayList();
			
			if (position == graphs.size()-1) 
			{ 
				forward.setEnabled(true);	
			}

			position--;
			before--;
			next--;							
			vertexes = (ArrayList)graphs.get(position);
			idents   = (ArrayList)tableIdent.get(position);
			graph.setGraph(vertexes);
			ident id = (ident)ids.get(row);
			tableDesign.setTableArray(idents,id, null);
			tableDesign.setCellColor(before,next);
			
			//System.out.println(position + " " + before + " " + next + " " + idents);
			if (position == 0) 
			{ 
				back.setEnabled(false);				
			}
          	}
        	});
		this.forward     = new JButton("Forward");			
		this.forward.addActionListener(new java.awt.event.ActionListener() {
		public void actionPerformed(java.awt.event.ActionEvent e) {		
			ArrayList vertexes = new ArrayList();
			ArrayList idents   = new ArrayList();
		
			if (position == 0) 
			{ 
				back.setEnabled(true);	
			}
		
			position++;	
			before++;
			next++;
			vertexes = (ArrayList)graphs.get(position);
			idents   = (ArrayList)tableIdent.get(position);
			graph.setGraph(vertexes);
			ident id = (ident)ids.get(row);
			tableDesign.setTableArray(idents,id, null);
			tableDesign.setCellColor(before,next);
		
			if (position == graphs.size()-1) 
			{ 
				forward.setEnabled(false);	
			}	
          	}
        	});
		this.reset       = new JButton("Reset");
		this.reset.addActionListener(new java.awt.event.ActionListener() {
		public void actionPerformed(java.awt.event.ActionEvent e) {		
			back.setEnabled(false);
			forward.setEnabled(true);
			position = 0;	
          	}
        	});

		/*****************************************
		* Zoom + button
		* ***************************************/

		this.zoomM = new JButton("Zoom +");
		this.zoomM.addActionListener(new java.awt.event.ActionListener() {
          	public void actionPerformed(java.awt.event.ActionEvent e) {
			zoom += 0.1;
			graph.getGraph().setScale(zoom);
          	}
        	});

		/*****************************************
		 * Zoom + button
		 * ***************************************/

		this.zoomL = new JButton("Zoom -");
		this.zoomL.addActionListener(new java.awt.event.ActionListener() {
          	public void actionPerformed(java.awt.event.ActionEvent e) {
			if (zoom != 0.1)
			{
				zoom -= 0.1;
				graph.getGraph().setScale(zoom);
			}
          	}
        	});

		this.row         = 0;
		this.initY       = 150;
		this.setTitle("Array Initialization");
	}

	public void setAndCreateTableArray(ArrayList ids)
	{
		ident id = (ident)ids.get(this.row);
		int i;
		ArrayList idents = new ArrayList();
	
		this.ids    = ids;
		this.name   = id.getName();	
		this.values = (ArrayList)id.getValue();
		// create graphs for each step of animation
		this.createStepsGraph();
		// initialize the current position in animation
		this.position = 0;
		this.before   = -1;
		this.next     = 0;

		// create table with each id
		for ( i = 0; i < values.size(); i++)
		{
			//System.out.println(id.getName() + " " + values.get(i));
			idents.add(i,"");
		}
		this.tableDesign.createTableArray(idents,id, null);
		// change initial color of the table 
		// (red in first row --- will be evaluated)
		this.tableDesign.setCellColor(this.before,this.next);
		back.setEnabled(false);
	}

	public void setGraphArray(Graph graph)
	{
		this.graph = graph;
	}

	public void setRow(int row)
	{
		this.row = row;
	}
	
	public void addNewComponents()
	{
		ArrayList vertexes     = new ArrayList();
		JPanel left            = new JPanel(new BorderLayout());
		JPanel panelTable      = new JPanel(new BorderLayout());			
		JPanel panelButton     = new JPanel();
		JPanel panel           = new JPanel(new BorderLayout());
		JScrollPane p = new JScrollPane(this.tableDesign.getTable());
		JScrollPane right;
		JSplitPane horizontal, vertical;
		
		p.setPreferredSize(new Dimension(100,180));
		panelTable.add(new JLabel("Identifiers",JLabel.CENTER),BorderLayout.NORTH);
		panelTable.add(p,BorderLayout.CENTER);
		left.add(panelTable, BorderLayout.NORTH);

		// gets the first step	
		vertexes = (ArrayList)this.graphs.get(0);	
		this.graph.setGraph(vertexes);

		right   = new JScrollPane(this.graph.getGraph());
		panelButton.add(reset);	
		panelButton.add(back);
		panelButton.add(forward);
		panelButton.add(zoomM);
		panelButton.add(zoomL);
		panel.add(panelButton,BorderLayout.CENTER);
		horizontal = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT, left, right);		
		vertical   = new JSplitPane(JSplitPane.VERTICAL_SPLIT, horizontal, panel);
		horizontal.setDividerLocation(250);
		this.getContentPane().add(vertical);
		this.setSize(850,initY-200);
		vertical.setDividerLocation(initY-280);
		this.setVisible(true);
	}
	
	private void createStepsGraph()
	{
		int i = 0, j = 0, initX = 250, posY = 0;
		ArrayList vertexes  = new ArrayList();
		ArrayList vertexes2 = new ArrayList();
		ArrayList idents    = new ArrayList();
	    
	        posY = values.size()*100;
	        vertexes = this.createVertex(vertexes, name, 80, posY, Color.GRAY, 60, 30);
	    
	        for (i = 0; i < this.values.size() + 1; i++)
	        {
			if ( i == 0)
			{
				vertexes = createEmptyCells(0);
				this.graphs.add(vertexes);
				for ( j = 0; j < values.size(); j++)
					idents.add("");
				this.tableIdent.add(idents);
			}
			else
			{
				vertexes  = createInitializedCells(i);
				vertexes2 = createEmptyCells(i);
				idents    = createValues(i);
				for ( j = 0; j < vertexes2.size(); j++)
				{	
					vertexes.add(vertexes2.get(j));
				}
				this.graphs.add(vertexes);
				this.tableIdent.add(idents);
			}
			this.initY       = 150;
	    	}
    	}

	private ArrayList createValues(int until)
	{
		int i;
		ArrayList idents = new ArrayList();
		
		for (i = 0; i < until; i++)
	        {
			idents.add(this.values.get(i));
		}

		for(i = until; i < this.values.size(); i++)
		{
			idents.add("");
		}
		
		return idents;	
	}
	
	private ArrayList createEmptyCells(int since)
	{
		int i = 0, initX = 250, posY = 0;
		ArrayList vertexes = new ArrayList();
	    	Color c;
	        posY = values.size()*100;
	        vertexes = this.createVertex(vertexes, name, 80, posY, Color.GRAY, 60, 30);
		
		for (i = since; i < values.size(); i++)
	        {
			if (i == since) { c = Color.RED; }
			else		{ c = Color.GRAY; }
					
			// node "="
		        vertexes = this.createVertex(vertexes, "=", initX, initY, c, 60, 30);
		        vertexes = this.createRelation(vertexes, 0, vertexes.size()-1);
		        // node "x[i]"		   
		   	vertexes = this.createVertex(vertexes, this.name + "[" + i + "]", initX+80, initY-40, c, 60, 30);
		   	vertexes = this.createRelation(vertexes, vertexes.size()-3, vertexes.size()-1);
		   	// node value
		   	vertexes = this.createVertex(vertexes, this.values.get(i).toString(), initX+80, initY+40, c, 60, 30);
		   	vertexes = this.createRelation(vertexes, vertexes.size()-5, vertexes.size()-1);
		   	initY += 150;
	    	}
		return vertexes;
	}

	private ArrayList createInitializedCells(int until)
	{
		int i = 0, initX = 250, posY = 0;
		ArrayList vertexes = new ArrayList();
	    
	        posY = values.size()*100;
	        vertexes = this.createVertex(vertexes, name, 80, posY, Color.GRAY, 60, 30);
		
		for (i = 0; i < until; i++)
	        {
			// node "var[index]=value"
		        vertexes = this.createVertex(vertexes, "<html>Name: " + name + "[" + i + "]" +
							       "<br>Value: " + this.values.get(i) + "</html>", 
						     initX, initY, Color.GREEN, 80, 40);
		        vertexes = this.createRelation(vertexes, 0, vertexes.size()-1);
		   	initY += 100;
	    	}
		return vertexes;
	}
	
	private ArrayList createVertex(ArrayList vertexes, String label, int positionX, int positionY, Color c,
			int width, int height)
    	{
		DefaultGraphCell cell;

    	    	cell  = this.graph.createRectangle(label, positionX, positionY, 
			    		       width, height, c, false);
   	    	cell.addPort();
	    	vertexes.add(cell);
		return vertexes;
    	}

    	public ArrayList createRelation(ArrayList vertexes, int parent, int child)
    	{
		DefaultEdge edge = new DefaultEdge();
	   	edge.setSource(((DefaultGraphCell)vertexes.get(parent)).getChildAt(0));
	    	edge.setTarget(((DefaultGraphCell)vertexes.get(child)).getChildAt(0));
	    	vertexes.add(edge);
	    	return vertexes;
    	}

}
