package Alma;

import java.util.ArrayList;
import java.util.Hashtable;
import java.util.Vector;
import java.util.Enumeration;

import javax.swing.JTable;
import javax.swing.JButton;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableCellRenderer;
import javax.swing.table.TableColumnModel;
import javax.swing.table.TableColumn;
import javax.swing.table.AbstractTableModel;
import javax.swing.JOptionPane;

import java.awt.Color;

public class TableDesign extends JTable
{
	private JTable table;
	private ViewArrayTableEditor view;
	private Hashtable types;
	
	public TableDesign()
	{
		this.view  = new ViewArrayTableEditor();
		this.table = new JTable(new MyTableModel());
		this.types = new Hashtable();
		this.table.getTableHeader().setReorderingAllowed(false);
		//this.table.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_ON);
	        TableColumnModel colModel = this.table.getColumnModel();
		TableColumn columnType = colModel.getColumn(3);
		TableColumn columnClass = colModel.getColumn(4);
		columnType.setCellEditor(view);		
		columnClass.setCellEditor(view);		
	}


	public void changeColor(int row1, int row2, int col, Color c1, Color c2)
	{
		TableColumnModel colModel = this.table.getColumnModel();
		TableColumn column = colModel.getColumn(col);
		column.setCellRenderer(new ColorCellRenderer(row1, row2, c1, c2 ));
	}

	public JTable getTable()
	{
		return this.table;
	}

	public void setTypes(Hashtable t) {
		this.types = t;
		this.view.setTypes(t);
	}

	public void createTable(ArrayList ids)
	{
		int i;
		ident id;
		String name, type, typeTable, classIdent, value = new String(), args = new String();
		
		MyTableModel dtm = (MyTableModel)this.table.getModel();

		for (i = 0; i < ids.size(); i++)
		{
			id         = (ident)ids.get(i);
			name       = id.getName();
			type       = id.getType();
			classIdent = id.getClassIdent();
			value      = new String();
			typeTable  = (this.types.containsKey(type)) ? 
					((String)this.types.get(type)) : type;

			if (id.isInitialized())	{
				if (id.getValue() != null) {
					value = id.getValue().toString();
				}
			}

			args = new String();
			if (classIdent.equals("function")) {
				Hashtable localInfo = (Hashtable)id.getLocalIdentifiers();
				TAB local           = (TAB)localInfo.get("arguments");
				       
				if (local.getEnv().size() != 0) {
					args = "<html><a href=\"\">See table</a></html>";;
				}
			}
			if (typeTable.equals("struct")) {
				value = "<html><a href=\"\">See table</a></html>";;
			}
        		dtm.addRow(new Object[]{name,type,classIdent, value,args});
		}
		this.view.setIds(ids);
	}

	public void createTable2(ArrayList ids, int b, int n)
	{
		int i;
		ident id;
		String name, type, classIdent, value = new String(), args = new String();
		
		MyTableModel dtm = (MyTableModel)this.table.getModel();

		for (i = 0; i < ids.size(); i++)
		{
			id         = (ident)ids.get(i);
			name       = id.getName();
			type       = id.getType();
			classIdent = id.getClassIdent();
			value       = new String();

			if (id.isInitialized())	{
				if (id.getValue() != null) {
					value = id.getValue().toString();
				}
			}
			
			args = new String();
			if (classIdent.equals("function")) {
				Hashtable localInfo = (Hashtable)id.getLocalIdentifiers();
				TAB local           = (TAB)localInfo.get("arguments");
				       
				if (local.getEnv().size() != 0) {
					args = "<html><a href=\"\">See table</a></html>";;
				}
			}

        		dtm.addRow(new Object[]{name,type,classIdent, value,args});
		}
		this.view.setIds(ids);
		this.setCellColor(b,n);
	}

	/** this method is used to buil up the table for arrays **/
	public void createTableArray(ArrayList values, ident id, Hashtable types)
	{
		int i;
		String name, type, classIdent;
		ArrayList array = new ArrayList();
		MyTableModel dtm = (MyTableModel)this.table.getModel();
	
		for ( i = 0; i < values.size(); i++)
		{
			name       = id.getName() + "[" + i + "]";
			type       = (types!=null) ? (
					(types.containsValue("integer")) ? 
					 getKey(types,"integer") :
					 "integer") : "integer";
			System.out.println(values.get(i).getClass());
			classIdent = id.getClassIdent();
			dtm.addRow(new Object[]{name,type,classIdent,values.get(i).toString()});
		}
	}

	/** this method gets the key for a type in an hashtable **/
	public String getKey(Hashtable types, String value) {
		Enumeration e = types.keys();
		String key    = new String(), str;
		boolean found = false;

		for (; e.hasMoreElements() && !found; ) {
			str = (String)e.nextElement();

			if (types.get(str).toString().equals(value)) {
				key   = str;
				found = true;
			}
		}
		return key;
	}

	/** this method is used to buil up the table for structs **/
	public void createTableStruct(ArrayList values)
	{
		int i;
		String name, type, classIdent;
		ArrayList array = new ArrayList();
		
		MyTableModel dtm = (MyTableModel)this.table.getModel();
	
		for ( i = 0; i < values.size(); i++)
		{
			ident id   = (ident)values.get(i);
			name       = id.getName();
			type       = id.getType();
			classIdent = id.getClassIdent();
			dtm.addRow(new Object[]{name,type,classIdent,id.getValue()});
		}
	}
	
	/** this method is used to set up the table for arrays **/
	public void setTableArray(ArrayList values, ident id, Hashtable types)
	{
		int i;
		String type = (types!=null) ? (
				(types.containsValue("integer")) ? 
				 getKey(types,"integer") :
				 "integer") : "integer";
		
		for ( i = 0; i < values.size(); i++)
		{
			this.table.setValueAt(id.getName()+"["+i+"]",i,0);
			this.table.setValueAt(type,i,1);
			this.table.setValueAt(id.getClassIdent(),i,2);
			this.table.setValueAt(values.get(i).toString(),i,3);			
			this.table.setValueAt("",i,4);			
		}
	}
	
	public void setTable(ArrayList ids)
	{
		int i;
		ident id;
		Object value;
		String valStr, type, classe, typeTable;
		ArrayList array = new ArrayList();
		MyTableModel dtm = (MyTableModel)this.table.getModel();
		int initRows = dtm.getRowCount(), toInit = ids.size();

		if (initRows >= toInit) {
			for (i = 0; i < toInit; i++) {
				id        = (ident)ids.get(i);
				value     = id.getValue();
				type      = id.getType();
				typeTable = (this.types.containsKey(type)) ? 
						((String)this.types.get(type)) : type;

				classe = id.getClassIdent();
			
				if (!id.isInitialized()) {	
					if (typeTable.equals("struct")) {
						valStr = "<html><a href=\"\">See table</a></html>";
					}
					else {
						valStr = ""; 
					}
				}
				else	{ 
					if (typeTable.equals("array") ||
					    typeTable.equals("struct") )	{
						valStr = "<html><a href=\"\">See table</a></html>";
					}
					else { valStr = (value == null) ? "" : value.toString();  }
				}

				/** this next two lines not be necessary because we need to change
				 * color of cells
				 * */
				this.table.setValueAt(id.getName(),i,0);
				this.table.setValueAt(id.getType(),i,1);
				this.table.setValueAt(id.getClassIdent(),i,2);
				this.table.setValueAt(valStr,i,3);		
				if (classe.equals("function")) {
					Hashtable localInfo = (Hashtable)id.getLocalIdentifiers();
					TAB local           = (TAB)localInfo.get("arguments");
				       
					if (local.getEnv().size() != 0) {
						this.table.setValueAt("<html><a href=\"\">See table</a></html>",i,4);
					}
					else {	this.table.setValueAt("",i,4);		}
				}
				else {	this.table.setValueAt("",i,4);		}

				this.view.setIds(ids);
			}

			// this part is to prevent have more lines that is necessary
			// case of function call (pass from arguments to execution of function
			int c            = dtm.getRowCount();
			int j;
			for (j = c; j > i ; --j) { dtm.removeRow(j-1);  }
		}
		else {
			for (i = 0; i < initRows; i++) {
				id     = (ident)ids.get(i);
				value  = id.getValue();
				type   = id.getType();
				typeTable = (this.types.containsKey(type)) ? 
						((String)this.types.get(type)) : type;
				classe = id.getClassIdent();
			
				if (!id.isInitialized()) {	valStr = ""; }
				else	{ 
					if (typeTable.equals("array") ||
					    typeTable.equals("struct"))	{
						valStr = "<html><a href=\"\">See table</a></html>";
					}
					else { valStr = (value == null) ? "" : value.toString();  }
				}

				/** this next two lines not be necessary because we need to change
				 * color of cells
				 * */
				this.table.setValueAt(id.getName(),i,0);
				this.table.setValueAt(id.getType(),i,1);
				this.table.setValueAt(id.getClassIdent(),i,2);
				this.table.setValueAt(valStr,i,3);		
				if (classe.equals("function")) {
					Hashtable localInfo = (Hashtable)id.getLocalIdentifiers();
					TAB local           = (TAB)localInfo.get("arguments");
				       
					if (local.getEnv().size() != 0) {
						this.table.setValueAt("<html><a href=\"\">See table</a></html>",i,4);
					}
					else {	this.table.setValueAt("",i,4);		}
				}
				else {	this.table.setValueAt("",i,4);		}

				this.view.setIds(ids);
			}

			for (i = initRows; i < ids.size(); i++) {
				id     = (ident)ids.get(i);
				value  = id.getValue();
				type   = id.getType();
				typeTable = (this.types.containsKey(type)) ? 
						((String)this.types.get(type)) : type;
				classe = id.getClassIdent();
			
				if (!id.isInitialized()) {	valStr = ""; }
				else	{ 
					if (typeTable.equals("array") ||
					    typeTable.equals("struct"))	{
						valStr = "<html><a href=\"\">See table</a></html>";
					}
					else { valStr = (value == null) ? "" : value.toString();  }
				}
        			dtm.addRow(new Object[]{id.getName(),type,classe, valStr});
			}
		}
	}

	/** Change color of cells that will be evaluated and the cells that already
	 * been evaluated
	 * */

	public void setCellColor(int before, int next)
	{
		int i = 0;

		if (before != -1 && next != -1) {
			for ( i = 0; i < 5; i++) {
				this.changeColor(before, next, i, Color.GREEN, Color.RED);
			}
		}
		else if (before != -1) {
			i = 0;
			for ( i = 0; i < 5; i++) {
				this.changeColor(before, -1, i, Color.GREEN, Color.WHITE);
			}
		}
		else if (next != -1) {
			i = 0;
			for ( i = 0; i < 5; i++) {
				this.changeColor(-1, next, i, Color.WHITE, Color.RED);
			}
		}
		else {
			i = 0;
			for ( i = 0; i < 5; i++) {
				this.changeColor(-1, -1, i, Color.WHITE, Color.WHITE);
			}
		}
	}

    class MyTableModel extends DefaultTableModel {
      MyTableModel() {
      setColumnIdentifiers(new String[] { "Identifier", "Type", "Class","Value", "Arguments"});
    }	
        public boolean isCellEditable(int row, int col) {
            if (col < 3) {
                return false;
            } else {
                return true;
            }
        }

     }
}
