/* 
 * ViewTableEditor.java  
 */

package Alma;

import javax.swing.AbstractCellEditor;
import javax.swing.table.TableCellEditor;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JTable;

import java.awt.Component;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.BorderLayout;

import java.util.ArrayList;
import java.util.Hashtable;

public class ViewArrayTableEditor extends AbstractCellEditor
                         implements TableCellEditor,
			            ActionListener {
    private String current;
    private JButton button;
    private ArrayList ids;
    private Hashtable types;
    private int row;
    protected static final String EDIT = "edit";

    public ViewArrayTableEditor() {
        //Set up the editor (from the table's point of view),
        //which is a button.
        this.button      = new JButton();
	this.ids         = new ArrayList();
	this.types       = new Hashtable();
	this.row    	 = 0;
        this.button.setActionCommand(EDIT);
        this.button.addActionListener(this);
        this.button.setBorderPainted(false);
    }

    public void setIds(ArrayList ids1)
    {
	    this.ids = (ArrayList)ids1.clone();
    }
   
    public void setTypes(Hashtable t) {
		this.types = t;
    }

    /**
     * Handles events from the editor button and from
     * the dialog's OK button.
     */
    public void actionPerformed(ActionEvent e) {
        if (EDIT.equals(e.getActionCommand())) {
		String type, typeTable;
            //The user has clicked the cell, so
            //bring up new table.
		if (getCellEditorValue().equals("<html><a href=\"\">See table</a></html>"))
		{
			ident id   = (ident)this.ids.get(this.row);
			type       = id.getType();
			typeTable  = (this.types.containsKey(type)) ? ((String)this.types.get(type)) : type;

			if (id.getClassIdent().equals("function"))
			{
				StructDialog dlg = new StructDialog(new JFrame(), 
							null,
							id.getLocalIdentifiers(),
							null,
							"Function arguments",
							"",
							true);
			}
			else if (typeTable.equals("array"))
			{
			 	AboutDialog dlg = new AboutDialog(new JFrame(), 
					this.row,
					this.ids,
					(ArrayList)id.getValue(),
					null,
					"Array values",
					true);				
			}
			else if (typeTable.equals("struct"))
			{
				//System.out.println(id.getLocalIdentifiers());
				StructDialog dlg = new StructDialog(new JFrame(), 
							null,
							id.getLocalIdentifiers(),
							null,
							"Struct",
							"",
							true);
			}
		}
		//Make the renderer reappear.
		fireEditingStopped();
        } 
    }

    //Implement the one CellEditor method that AbstractCellEditor doesn't.
    public Object getCellEditorValue() {
        return this.current;
    }

    //Implement the one method defined by TableCellEditor.
    public Component getTableCellEditorComponent(JTable table,
                                                 Object value,
                                                 boolean isSelected,
                                                 int row,
                                                 int column) {
        this.current = (String)value;
	this.row     = row;
        return this.button;
    }
}


