/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package Alma.animation.patterns;

import Alma.animation.Actor;
import java.util.ArrayList;

/**
 *
 * @author Nuno Oliveira
 */
public class APAggregator extends AnimationPattern{

    private ArrayList<Actor> aggregator;
    private ArrayList<Actor> listReference;
    private Actor actor;
    private AnimationPattern apMOVE;
    private AnimationPattern apLABEL;

    public APAggregator(ArrayList<Actor> objs, Actor obj, int[] poses, int x, int y) {
        super(obj, poses);
        this.aggregator = new ArrayList<Actor>();
        this.actor = (Actor)obj.clone();
        this.listReference = objs;
        this.setIsAggregator(true);

        //APMove  is used to create the position of the actor
        this.apMOVE = new APMove(this.actor, poses, x, y);
        this.apLABEL = null;
    }

    public APAggregator(ArrayList<Actor> objs, Actor obj, int[] poses, int x, int y, String label) {
        super(obj, poses);
        this.aggregator = new ArrayList<Actor>();
        this.actor = (Actor)obj.clone();
        this.listReference = objs;
        this.setIsAggregator(true);

        //APMove and APLabel are used to create the position of the actor and to label it
        this.apMOVE = new APMove(this.actor, poses, x, y);
        this.apLABEL = new APLabel(this.actor, poses, label);

    }

    public APAggregator(ArrayList<Actor> objs, Actor obj, int[] poses, int x, int y, String label, String variable) {
        super(obj, poses);
        this.aggregator = new ArrayList<Actor>();
        this.actor = (Actor)obj.clone();
        this.listReference = objs;
        this.setIsAggregator(true);

        //APMove and APLabel are used to create the position of the actor and to label it
        this.apMOVE = new APMove(this.actor, poses, x, y);
        this.apLABEL = new APLabel(this.actor, poses, label, variable);

    }


    public ArrayList<Actor> getAggregator() {
        return aggregator;
    }

    public void setAggregator(ArrayList<Actor> aggregator) {
        this.aggregator = aggregator;
    }

    


    @Override
    public void animate() {
        this.aggregator = listReference;
        this.actor.setIsAggregated(true);
        this.aggregator.add(this.actor);
        this.apMOVE.animate();
        if(this.apLABEL!=null){
            this.apLABEL.setTab(this.getTab());
            ((APLabel)this.apLABEL).animate();
        }

        //SIDE EFFECT NECESSITY
        this.listReference = aggregator;

    }

}
