/*****************************************************************
 *
 * @author Daniela da Cruz
 * @version 2.0, September 2006
 *
 * danieladacruz@di.uminho.pt
 *
 * This class intends to fetch the entire contents of a text file, 
 * and return it in a String.
 * This style of implementation does not throw Exceptions to the caller.
 *
 *****************************************************************/

package Alma;

import  java.io.File;
import  java.io.FileNotFoundException;
import  java.io.FileReader;
import  java.io.IOException;
import  java.io.BufferedReader;

public class ReadFile {

	StringBuffer contents;
	BufferedReader input;
	String line;
	    
	public ReadFile()
	{
		contents = new StringBuffer();
		input    = null;
		line     = null; //not declared within while loop
	}


	/**************************************************************
	 * @param aFile is a file which already exists and can be read.
	 * ************************************************************/

	public String getContents(File aFile) 
	{
		
		try 
		{
			// use buffering, reading one line at a time
			// FileReader always assumes default encoding is OK!

	  		input = new BufferedReader( new FileReader(aFile) );
	  
		    	/*
		         * readLine is a bit quirky :
		         * it returns the content of a line MINUS the newline.
		         * it returns null only for the END of the stream.
		         * it returns an empty String if two newlines appear in a row.
		         */
		        while (( line = input.readLine()) != null)
			{
		        	contents.append(line);
				contents.append(System.getProperty("line.separator"));
			}
		}
		catch (FileNotFoundException ex) 
		{
			ex.printStackTrace();
		}
		catch (IOException ex)
		{
			ex.printStackTrace();
		}
		finally 
		{
			try 
			{
		        	if (input!= null) 
				{
					//flush and close both "input" and its underlying FileReader
					input.close();
				}
			}
			catch (IOException ex) 
			{
				ex.printStackTrace();
			}
		}

		return contents.toString();
	  }
}
