package Alma;

import Alma.animation.Actor;
import Alma.animation.DrawingPanel;
import  Lisa.Parser.CTreeNode;

import  javax.swing.JOptionPane;

import  java.util.ArrayList;
import  java.util.Hashtable;
import javax.swing.JFrame;

public class Rewrite
{
	private ArrayList changedNodes; 
	private boolean isByCopy;
	private TAB tab;
	private Motor motor;
	private Hashtable types;
	private CTreeNode rewritten = null, nextNode = null;
	private String fileName;
    private ArrayList<Actor> actors;
    private JFrame frame;
		
	public Rewrite()
	{
		this.changedNodes   = new ArrayList();
		this.motor          = new Motor();
		this.types	    = new Hashtable();
	}


    public void setActors(ArrayList<Actor> as) {
        this.actors = as ;
    }

    public void setFrame(JFrame jf) {
        this.frame = jf;
    }



	public void setTAB(TAB tab)
	{
		this.tab = tab;
	}

	public void setTypes(Hashtable types)
	{
		this.types = types;
	}

	public void setIsByCopy(boolean isByCopy)
	{
		this.isByCopy = isByCopy;
	}

	public void setFileName(String f) {
		this.fileName = f;
	}

	public void setRewritten()
	{
		this.rewritten = null;
	}

	public void setNextNode()
	{
		this.rewritten = null;
	}

	public CTreeNode getRewritten()
	{
		return this.rewritten;
	}

	public CTreeNode getNextNode()
	{
		return this.nextNode;
	}

	public TAB getTAB()
	{
		return this.tab;
	}

	public ArrayList getChangedNodes()
	{
		return this.changedNodes;
	}

	public void print(CParentNode t)
	{
		String name;
		CTreeNode node;
		
		if (t!=null)
		{
			node = (CTreeNode)t.getLabel();
			name = node.getSymbol().getName();
			System.out.println(name);
			print(t.getChild());
			print(t.getChild().getSibling());
		}
	}

	public void rewriteStruct(CParentNode subtree)
	{
		String name, nameVar, type, typeTable;
		CTreeNode node;
		boolean flag;
		
		node = (CTreeNode)subtree.getLabel();
		name = node.getSymbol().getName();

		// first test: is assignment
		// second test: is not an indexation or struct access
		if (name.equals("ASSIGN") && !((CAlmaNode)node).getType().equals("ASSIGN_OR_STRUCT"))
		{
			nameVar   = ((CAlmaNode)node.getNodeAt(0)).getName();
			type      = this.tab.getType(nameVar);
			typeTable = (this.types.containsKey(type)) ? ((String)this.types.get(type)) : type;

			// first test: is a structured data type
			// the second one: to garantee that we are not assigning
			// a value to a variable in a struct
			// the third: is not already evaluated
			if (typeTable.equals("struct"))
			{
				if (!(((CTreeNode)subtree.getChild().getLabel()).getAttributes()[2]).toString().equals("ARRAY_OR_STRUCT")
						&&
						!subtree.getChild().getSibling().Evaluated())
				{	
					subtree.setEvaluateSubTree(true);
				}
			}
		}
	}

	public boolean rewriteFunc(CParentNode subtree, boolean eval)
	{
		String name;
		CTreeNode node;
		boolean res = false;
		
		node = (CTreeNode)subtree.getLabel();
		name = node.getSymbol().getName();

		// if is "FUNC" so is a declaration of a function
		// and in this case we do not evaluate this node
		if (name.equals("FUNC"))
		{
			subtree.setEvaluateSubTree(true);
			res = true;
		}
		return res;
	}

	// this method is to not rewrite the children of a CALL node
	public void rewriteCall(CParentNode subtree)
	{
		String name;
		CTreeNode node;
		
		node = (CTreeNode)subtree.getLabel();
		name = node.getSymbol().getName();

		if (name.equals("CALL"))
		{
			if (subtree.getChild()!=null) {
				subtree.getChild().setEvaluateSubTree(true);
			}
		}
	}

	/** returns the rewritten node **/
	public void newrewrite(CParentNode t, boolean eval)
	{
		String name, nameVar;
		CTreeNode node;
		boolean flag = false, temp = false;
		ArrayList nodesCanRewrite = new ArrayList();
	        nodesCanRewrite.add("READ");
	        nodesCanRewrite.add("WRITE");
	        nodesCanRewrite.add("OPER");
	        nodesCanRewrite.add("OPERREL");
	        nodesCanRewrite.add("CALL");
	        nodesCanRewrite.add("RETURN");
	        nodesCanRewrite.add("ASSIGN");

	//try
	//{	
		if (t!=null)
		{
			node = (CTreeNode)t.getLabel();
			name = node.getSymbol().getName();

			if (!t.isEvaluatedChild()) {	
				rewriteFunc(t.getChild(),eval);
				rewriteCall(t.getChild());	
				rewriteStruct(t.getChild());	
				
				if (!eval) {
					newrewrite(t.getChild(),eval);	
				}
			}
			else if (!t.isEvaluatedSibling1())
			{
				rewriteFunc(t.getChild().getSibling(),eval);
				rewriteCall(t.getChild().getSibling());	
				rewriteStruct(t.getChild().getSibling());	
				
				if (name.equals("WHILE") || name.equals("IF"))
				{
					Object value = motor.getCorrectValue(t.getChild());
					if (value.toString().equals("false"))
					{
                        if (t.getChild().getSibling()!=null) {
							t.getChild().getSibling().setEvaluateSubTree(true);	
						}
					}
					else 
					{	if (name.equals("IF") && t.getChild().getSibling().getSibling() != null)
							{ t.getChild().getSibling().getSibling().setEvaluateSubTree(true);	}
					}
				}				
				if (!eval) {
					newrewrite(t.getChild().getSibling(),eval);
				}
			}
			// in case of IF node -- have 3 childs (else statement)
			else if (!t.isEvaluatedSibling2()) { 
				rewriteFunc(t.getChild().getSibling().getSibling(),eval);
				rewriteCall(t.getChild().getSibling().getSibling());	
				rewriteStruct(t.getChild().getSibling().getSibling());	
				
				if (!eval) {				
					newrewrite(t.getChild().getSibling().getSibling(),eval);	
				}
			}
			else
			{
				if (rewritten == null) {
					flag = evaluateSubTree(t);			
				        t.setEvaluated(true);
					if (flag) { rewritten = (CTreeNode)t.getLabel();  
					//System.out.println("Reescrito: " + rewritten); 
					}
				}
		
				if (!eval)	{	newrewrite(t.getParent(),flag);	}
				else		{	if (!(nodesCanRewrite.contains(name)) && !name.equals("WHILE")) {
					 			t.setEvaluated(true);
							}
							else {
								if (name.equals("WHILE"))
								{
									Object value = motor.getCorrectValue(t.getChild());
									if (value.toString().equals("true"))
									{ t.setEvaluateSubTree(false);	}
								}
							}

							newrewrite(t.getParent(),eval); 
						}
			}
		}
	/*}
	catch (Exception e)
	{
		JOptionPane.showMessageDialog(null,"Error evaluating node! " +
				"Program will abort.\nPlease analyze your souce code.\n" +
				"Problem: " + e.getMessage());
		System.exit(0);
	}*/	
	
	}

	public void evaluateReadNode(CParentNode subtree, CTreeNode node)
	{
		String inputValue = new String(), type, leftOper, rightOper, typeTable;
		CTreeNode child;
		Object[] attributes = new Object[3], attr = new Object[3];
		ArrayList values;
		Object value1;
		int resInt;

		while(inputValue.length() == 0)	{
			inputValue = JOptionPane.showInputDialog("Please input a value");
            //tweak to accept only numbers :P
            try{
                Integer.parseInt(inputValue);
            }
            catch(Exception e){
                inputValue = "";
            }
		}

		child         = (CTreeNode)subtree.getChild().getLabel(); 
		type          = child.getAttributes()[2].toString();
		leftOper      = child.getAttributes()[0].toString();

		if (type.equals("ARRAY_OR_STRUCT")) {
			attr	      = child.getAttributes();
			type          = this.tab.getType(attr[0].toString());
			typeTable     = (this.types.containsKey(type)) ? ((String)this.types.get(type)) : type;

			if (typeTable.equals("array"))	{
				value1 = this.tab.getTable(leftOper);
				if (value1 != null) { values = (ArrayList)value1; }
				else		   { values = new ArrayList();   }

				resInt 	      = Integer.parseInt(attr[3].toString());	
				if (resInt+1 > values.size()) { values = initializeArray(values,resInt); }
				values.set(resInt, inputValue);
				subtree.setValue(inputValue);
				this.tab.putTable(leftOper,values);
			}
			else if (typeTable.equals("struct"))	{
				Object[] attrs = ((CTreeNode)subtree.getChild().getLabel()).getAttributes();
				rightOper = attrs[3].toString();
				this.tab.putLocalTable(leftOper,rightOper,subtree.getChild().getSibling().getValue());
			}
		}
		else	{
			subtree.setValue(inputValue);
			this.tab.putTable((String)child.getAttributes()[0],inputValue);
		}

	//	this.tab.putTable(node.getNodeAt(0).getAttributes()[0].toString(),inputValue);
	}

	public void evaluateArrayNode(CTreeNode node, CParentNode subtree)
	{
		String name      = node.getSymbol().getName();
		Object[] attrs   = node.getNodeAt(0).getAttributes();
		String type      = this.tab.getType(attrs[0].toString());
		String typeTable = (this.types.containsKey(type)) ? ((String)this.types.get(type)) : type;
		String nameVar;
		ArrayList values = new ArrayList();

		//System.out.println("Rewrite: " + typeTable);

		// in future --- add to test: and 'i want see this initialization'			
		if (node!= null && name.equals("ASSIGN") && node.getAttributes()[2].toString().equals("null")
				&& typeTable.equals("array"))
		{
			if (!attrs[2].toString().equals("ARRAY_OR_STRUCT"))
			{
				nameVar         = node.getNodeAt(0).getAttributes()[0].toString();
				System.out.println("\n\nAQUI2: " + nameVar + "\n");
				if (subtree.getChild().getSibling().getValue()!=null) {
					values = (ArrayList)subtree.getChild().getSibling().getValue();
				}
				AboutDialog dlg = new AboutDialog(null, 
							this.tab.getIndexOfIdent(nameVar), this.tab.getEnv(),
							values, 
							this.types,
							"Array Initialization",	false);
			}
		}
	}

	public boolean evaluateStructNode(CTreeNode node)
	{
		int i          = 0;
		ident id;
		String name      = node.getSymbol().getName();
		Object[] attrs   = node.getNodeAt(0).getAttributes();
		String type      = this.tab.getType(attrs[0].toString());
		String typeTable = (this.types.containsKey(type)) ? ((String)this.types.get(type)) : type;
		String nameVar   = new String();
		boolean res      = false;

		if (node!= null && name.equals("ASSIGN") && node.getAttributes()[2].toString().equals("null")
				&& typeTable.equals("struct"))
		{
			if (!attrs[2].toString().equals("ARRAY_OR_STRUCT"))
			{
				nameVar = ((CAlmaNode)node.getNodeAt(0)).getName();
				id = this.tab.getIdent(nameVar);
				ArrayList local = (ArrayList)id.getLocalIdentifiers();
				
				StructDialog dlg = new StructDialog(null, node.getNodeAt(1), 
						local, 
						this.types,
						"Struct Initialization",
						this.fileName,
						false);
				res              = true;
			}
		}

		return res;
	}


	private void evaluateCallNode(CTreeNode node,CParentNode subtree)
	{
		String nameVar  = ((CAlmaNode)node).getName();
		ident id 	= this.tab.getIdent(nameVar);
		ArrayList local = this.tab.collectIdentLevel(id.getLevel());
		ArrayList aux   = new ArrayList();
		TAB localFunc   = new TAB(local);
		TAB localArgs   = new TAB(this.tab.getEnv());
		Hashtable val   = (Hashtable)localFunc.getLocalValue(nameVar);
		CTreeNode funcN = (CTreeNode)val.get("node"); 

		if (val != null) { 
			localArgs.addEnv2(((TAB)val.get("arguments")).getEnv()); 

			aux.addAll(((TAB)val.get("arguments")).getEnv());
			aux.addAll(((TAB)val.get("variables")).getEnv());			
			localFunc.addEnv(aux); 
		}
					
		ArrayList expr = new ArrayList();

		//localTAB.print();
		//System.out.println("Call: " + funcN.getNodeAt(0));
		//print( funcN.getNodeAt(0),0);
		motor.processNodes(node.getNodeAt(0),expr);
		//System.out.println("--------------------");
		CTreeNode n = motor.mappingArgsExpr(funcN.getNodeAt(0),expr,0);
		//print(n,0);

		FuncDialog dlg = new FuncDialog(this.frame, this.types, localArgs.getEnv(), localFunc.getEnv(),
						subtree, funcN, nameVar, this.fileName, new DrawingPanel(this.actors));
		if (dlg.getValue() != null)
		{
			subtree.setValue(dlg.getValue());
		}
		//System.out.println("Resultado: " + dlg.getValue());
	}

	private boolean evaluateSubTree(CParentNode subtree)
	{
		CTreeNode node      = (CTreeNode)subtree.getLabel();
		CTreeNode child, childAux, sibling, aux;
		Object[] attributes = new Object[3];
		Object[] orig       = new Object[3];
		Object[] attr       = new Object[4];
		Object value	    = null;
		String oper, typeVar, 
		       leftOper, rightOper, name, type, nameChild, typeTable, 
		       inputValue = new String();
		Object value1, value2;
		int resInt;
		ArrayList values      = new ArrayList();
		boolean resBool, flag = false;

		name       = node.getSymbol().getName();
		attributes = node.getAttributes();
		orig	   = node.getAttributes();
		
		//try
		//{
			if (name.equals("ASSIGN"))
			{
				// if is a struct initialization then we don't need to
				// test if is a array initialization
				if (!evaluateStructNode(node))
				{
					evaluateArrayNode(node,subtree);
				}

				type = attributes[2].toString();
	
				if (type.equals("ARRAY_OR_STRUCT"))
				{

					child      = (CTreeNode)subtree.getChild().getLabel();
					attributes = child.getAttributes();
					type       = this.tab.getType(attributes[0].toString());
					typeTable  = (this.types.containsKey(type)) ? ((String)this.types.get(type)) : type;
		
					if (typeTable.equals("array"))	
					{
						value1 = this.tab.getTable((String)(attributes[0]));
						if (value1 != null) { values = (ArrayList)value1; }
						else		   { values = new ArrayList();   }
						System.out.println("AQUI: " + value1);
						//}values = (ArrayList)values.clone();
						value1 = motor.getCorrectValue(subtree.getChild().getSibling());
						resInt = Integer.parseInt(value1.toString());	
						Object[] attrs = {attributes[0], attributes[1],  "ARRAY_OR_STRUCT" , value1};
						node.setAttributes(attrs);
						// this line is to simulate an variable (gets it's value)
						if (values.size() > resInt) {
							subtree.setValue(values.get(resInt));
						}
					}
					else if (typeTable.equals("struct"))
					{
						sibling = (CTreeNode)subtree.getChild().getSibling().getLabel();

						Object v = this.tab.getLocalValue(attributes[0].toString(), sibling.getAttributes()[0].toString());
						Object[] attrs = {attributes[0],  attributes[1],  "ARRAY_OR_STRUCT",  sibling.getAttributes()[0]};
						node.setAttributes(attrs);
						subtree.setValue(v);	
					}
				}	
				else
				{
					child         = (CTreeNode)subtree.getChild().getLabel(); 
					type          = child.getAttributes()[2].toString();
					leftOper      = child.getAttributes()[0].toString();
				
					//System.out.println("---> " + leftOper + " " + child.getAttributes().length);
					if (type.equals("ARRAY_OR_STRUCT"))
					{
						attr	      = child.getAttributes();
						type          = this.tab.getType(attr[0].toString());
						typeTable     = (this.types.containsKey(type)) ? ((String)this.types.get(type)) : type;

						if (typeTable.equals("array"))
						{
							value1 = this.tab.getTable(leftOper);
							if (value1 != null) { values = (ArrayList)value1; }
							else		   { values = new ArrayList();   }

							attributes[1] = motor.getCorrectValue(subtree.getChild().getSibling());
							resInt 	      = Integer.parseInt(attr[3].toString());	
							if (resInt+1 > values.size()) { values = initializeArray(values,resInt); }
							values.set(resInt, Integer.parseInt(attributes[1].toString()));
							this.tab.putTable(leftOper,values);
						}
						else if (typeTable.equals("struct"))
						{
							Object[] attrs = ((CTreeNode)subtree.getChild().getLabel()).getAttributes();
							rightOper = attrs[3].toString();
							this.tab.putLocalTable(leftOper,rightOper,subtree.getChild().getSibling().getValue());
						}
					}
					else
					{
						attributes[1] = subtree.getChild().getSibling().getValue(); 
						node.setAttributes(attributes);
						//System.out.println("ASSIGN: " + (String)child.getAttributes()[0] + " " + attributes[1]);
						this.tab.putTable((String)child.getAttributes()[0],attributes[1]);
					}
				}
				flag = true;
			}
			else if(name.equals("CALL"))
			{
				evaluateCallNode(node,subtree);
				flag=true;
			}
			else if(name.equals("RETURN"))
			{
				flag=true;
				// in case of be in form of "return expr;"
				// otherwise, could be just "return;"
				if (subtree.getChild() != null) { 
					if (subtree.getChild().getValue() != null) {
						subtree.setValue(subtree.getChild().getValue()); 
					}
					else {
						value 		 = motor.getCorrectValue(subtree.getChild());
						subtree.setValue(value); 
					}
				}
				else {}
				
			}			
			else if (name.equals("OPER") || name.equals("OPERREL"))
			{
				attributes = node.getAttributes();
				oper       = attributes[0].toString();
				value1     = subtree.getChild().getValue();
				value2     = subtree.getChild().getSibling().getValue();
				
				if (oper.equals("+"))
				{
					resInt = Integer.parseInt(value1.toString()) + Integer.parseInt(value2.toString());
					subtree.setValue(resInt);
				}
				else if (oper.equals("-"))
				{
					resInt = Integer.parseInt(value1.toString()) - Integer.parseInt(value2.toString());
					subtree.setValue(resInt);
				}
				else if (oper.equals("*"))
				{
					resInt = Integer.parseInt(value1.toString()) * Integer.parseInt(value2.toString());
					subtree.setValue(resInt);
				}
				else if (oper.equals("%"))
				{
					resInt = Integer.parseInt(value1.toString()) % Integer.parseInt(value2.toString());
					subtree.setValue(resInt);
				}
				else if (oper.equals("/"))
				{
					resInt = Integer.parseInt(value1.toString()) / Integer.parseInt(value2.toString());
					subtree.setValue(resInt);
				}
				else if (oper.equals("<"))
				{
					resBool = Integer.parseInt(value1.toString()) < Integer.parseInt(value2.toString());
					subtree.setValue(resBool);
				}
				else if (oper.equals(">"))
				{
					resBool = Integer.parseInt(value1.toString()) > Integer.parseInt(value2.toString());
					subtree.setValue(resBool);
				}
				else if (oper.equals("<="))
				{
					resBool = Integer.parseInt(value1.toString()) <= Integer.parseInt(value2.toString());
					subtree.setValue(resBool);
				}
				else if (oper.equals(">="))
				{
					resBool = Integer.parseInt(value1.toString()) >= Integer.parseInt(value2.toString());
					subtree.setValue(resBool);
				}
				else if (oper.equals("||"))
				{
					resBool = Boolean.valueOf(value1.toString()) || Boolean.valueOf(value2.toString());
					subtree.setValue(resBool);
				}
				else if (oper.equals("&&"))
				{
					resBool = Boolean.valueOf(value1.toString()) && Boolean.valueOf(value2.toString());
					subtree.setValue(resBool);
				}
				else if (oper.equals("!="))
				{
					resBool = Integer.parseInt(value1.toString()) != Integer.parseInt(value2.toString());
					subtree.setValue(resBool);
				}
				else if (oper.equals("=="))
				{
					resBool = Integer.parseInt(value1.toString()) == Integer.parseInt(value2.toString());
					subtree.setValue(resBool);
				}
				flag = true;
			}
			else if (name.equals("WRITE"))
			{
				flag = true;
			}
			else if (name.equals("READ"))
			{
				evaluateReadNode(subtree, node);
				flag = true;
			}
			else if (node.getSymbol().getName().equals("VAR"))
			{
				//JOptionPane.showMessageDialog(null," " + attributes[0] + " " + this.tab.getTable((String)attributes[0]));
				//System.out.println("\nVAR: " + attributes[0] + " " + this.tab.getTable((String)attributes[0]));
				subtree.setValue(this.tab.getTable((String)attributes[0]));
			}
			else if (node.getSymbol().getName().equals("CONST"))
			{
				subtree.setValue(attributes[1]);
			}
			else if (node.getSymbol().getName().equals("LST"))
			{
				ArrayList result = new ArrayList();
				processLstNode(node,result);
				subtree.setValue(result);
			}
	/*	}
		catch (Exception e)
		{
			JOptionPane.showMessageDialog(null,"Error evaluating node! Program will abort.\nPlease analyze your souce code.\n" +
					"Problem: " + e.getMessage());
			//System.exit(0);
		}	*/
		return flag;
	}


	/** Process an LstNode - in case of be an array of integers,
	 * so you process all terminal elements and they are added to an
	 * ArrayList, that then will be use on identifiers table
	 * 
	 * @param node   - node to process
	 * @param result - the ArrayList where atomic elements are saved
	 *
	 * @return void 
	 *
	 **/	
        public void processLstNode(CTreeNode node, ArrayList result)
	{
           CTreeNode[] children;
	   CTreeNode child;
	   int i=0, index=-1;
	   Object[] ats = new Object[3];

	   if (node instanceof CConstNode)
	   {
		ats = node.getAttributes();
		result.add(ats[1]);
	   }
	   else
	   {
		children = (CTreeNode[])node.getNodes();
	   	for(i = 0; i < children.length; i++)
		{
			child = (CTreeNode)children[i];
			processLstNode(child,result);
		}
	   }
        }

	/** Initializes an array with empty strings to be possible
	 * make array.set(pos,val)
	 * */
	public ArrayList initializeArray(ArrayList values, int until)
	{
		int i;
		// to pass until the values already initialized
		for ( i = 0; i < values.size(); i++);
		// initialze other positions to increment "size"
		for (; i < until+1; i++) { values.add(""); }

		return values;
	}


}
