/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package Alma.animation.patterns;

import Alma.animation.*;

/**
 *
 * @author Nuno Oliveira
 */
public class APLabel extends AnimationPattern {

    //the label (text before the value of a variable)
    private String label;
    //the final label
    private String labelF;
    //Says whether it is needed to evaluate the value of a variable
    private boolean needEvaluation;
    //the variable used to get the value on the actor state
    private String labelVar;





    public APLabel(Actor obj, int[] poses, String labelText) {
        super(obj, poses);
        this.label = labelText;
        this.needEvaluation = false;
        this.setIsAggregator(false);

    }

    public APLabel(Actor obj, int[] poses, String label, String labelVar) {
        super(obj, poses);
        this.label = label;
        this.labelVar = labelVar;
        this.needEvaluation = true;
        this.setIsAggregator(false);

    }



    
    public String getLabelF() {
        return labelF;
    }

    public void setLabelF(String labelF) {
        this.labelF = labelF;
    }

    public String getLabel() {
        return label;
    }

    public void setLabel(String label) {
        this.label = label;
    }

    public String getLabelVar() {
        return labelVar;
    }

    public void setLabelVar(String labelVar) {
        this.labelVar = labelVar;
    }

    public boolean isNeedEvaluation() {
        return needEvaluation;
    }

    public void setNeedEvaluation(boolean needEvaluation) {
        this.needEvaluation = needEvaluation;
    }



    


    @Override
    public void animate() {
        this.labelF = label;
        if(needEvaluation){
            //System.out.println(labelF);
            String v = getValue(this.labelVar).toString();
            if(v!=null){this.labelF += v;}
            //System.out.println(labelF);
        }
        
        this.getObj().setLabel(labelF);
        this.getObj().setIsLabeled(true);
        this.getObj().setUsedPoses(super.getPoses());
    }

}
