/** 
 * Pattern to move one object in a bi-dimensional space.
 * In Fact it just gets the value of the position variables from the IdTables
 */

package Alma.animation.patterns;

import Alma.animation.*;
import java.awt.Point;



/**
 *
 * @author Nuno Oliveira
 */
public class APMove extends AnimationPattern {

    //the coordinate to store the position of the actor
    private Point coord;
    //says whether it is needed to get the (x,y)'s value from the id table
    private boolean needEvaluation;
    //the variables to store the name of the variable of the state of the actor
    private String vx, vy;


    public APMove(Actor obj,  int[] poses, int x, int y) {
        super(obj, poses);
        this.coord = new Point(x, y);
        this.needEvaluation = false;
        this.setIsAggregator(false);
    }

    public APMove(Actor obj, int[] poses, String Xvar, String Yvar){
        super(obj, poses);
        this.needEvaluation = true;
        this.vx = Xvar;
        this.vy = Yvar;
        this.setIsAggregator(false);
        
    }


    public Point getCoord() {
        return coord;
    }

    public void setCoord(Point coord) {
        this.coord = coord;
    }
  
    
    

    
    @Override
    public void animate() {
        if(needEvaluation){
            this.coord = new Point((Integer)getValue(this.vx), (Integer)getValue(this.vy));
        }
        
        this.getObj().setX(coord.x);
        this.getObj().setY(coord.y);
        this.getObj().setUsedPoses(this.getPoses());
    }
    
    

}
