package Alma;

import java.awt.Color;
import java.awt.geom.Rectangle2D;

import javax.swing.BorderFactory;

import org.jgraph.graph.DefaultGraphCell;
import org.jgraph.graph.GraphConstants;

public class MyEllipseGraphCell extends DefaultGraphCell {

	/**
	 * Creates a custom graph cell with a given user object
	 * 
	 * @param userObject
	 */
	public MyEllipseGraphCell(Object userObject, Rectangle2D bounds) {
		super(userObject);
		this.initialize(bounds);
	}
	
	/**
	 * Initializes the graph cell
	 * 
	 */
	private void initialize(Rectangle2D bounds) {
		// set cell background
//		GraphConstants.setBackground(this.getAttributes(), Color.BLUE);
		// the background color should be visible
		GraphConstants.setOpaque(this.getAttributes(), true);
		// set the border style of the cell
		GraphConstants.setBorder(this.getAttributes(), BorderFactory
				.createLineBorder(Color.BLACK));
		// unfortunately JGraph don't takes the color from the Border,
		// so it has to be configure separate
		GraphConstants.setBorderColor(this.getAttributes(), Color.BLACK);
		// cell should be resizable
		GraphConstants.setSizeable(this.getAttributes(), true);
		// set cell bounds
		GraphConstants.setBounds(this.getAttributes(), bounds);
	}
}
