package Alma;

import Lisa.Parser.CTreeNode;
import java.util.*;

public class TAB {
        private ArrayList env;
	private boolean isByCopy;

	/** Default constructor */
        public TAB() 
	{
		this.env  =  new ArrayList();
        }    


	public void setIsByCopy(boolean t) {
		this.isByCopy = t;
	}

	/** Constructor with a array of identifiers */
        public TAB(ArrayList env1) 
	{
		int i;
		this.env  =  new ArrayList();
		
		for ( i = 0; i < env1.size(); i++)
		{
			this.env.add((ident)env1.get(i));
		}
		
        }    

	/** gets the set of identifiers
	 * */
	public ArrayList getEnv()
	{
		return (ArrayList)this.env.clone();
	}

	/** sets the set of identifiers
	 * */
	public void setEnv(ArrayList aux)
	{
		this.env = (ArrayList)aux.clone();
	}

	/** verify if there is an function that could be the entry
	 * point of the program
	 *
	 * if the index in table in not -1 so there exist the entry point
	 * (if is class "function")
	 *
	 * @param name - the name of the entry point
	 * @return bool 
	 * */
	public boolean haveEntryPoint(String name)
	{
		int index   = this.getIndexOfIdent(name);
		String type = new String();
		if (index != -1) {
			ident id = (ident)this.env.get(index);
			type = id.getClassIdent();
		}

		//System.out.println(index + " , " + type);
		return ( type.equals("function"));
	}

	/** add identifiers to the environment 
	 * (do not overrides in case of duplicated)
	 * **/
	public void addEnv(ArrayList more)
	{
		int i = 0, indexOf = -1;
		ident id;

		for ( i = 0; i < more.size(); i++)
		{
			id = (ident)more.get(i);
			indexOf = this.getIndexOfIdent(id.getName());
			if (indexOf != -1) {
				this.env.remove(env.get(indexOf));
			}	
			this.env.add(id);
		}
	}

	/** add identifiers to the environment 
	 * (overrides in case of duplicated)
	 * **/
	public void addEnv2(ArrayList more)
	{
		int i = 0, indexOf = -1;
		ident id;

		for ( i = 0; i < more.size(); i++)
		{
			id = (ident)more.get(i);
			indexOf = this.getIndexOfIdent(id.getName());
			this.env.add(id);
		}
	}

	/*** how many identifiers have the table:
	 * */
	public int size()
	{
		return this.env.size();
	}

	/** clear identifiers table
	 */

	public void clear()
	{
		this.env.clear();
	}

	/** clone identifiers table
	 */
	public Object clone()
	{
		Iterator it;
		ArrayList tmp = new ArrayList();
		ident id;
		TAB tab = new TAB();
		
		//this.print();
		for ( it = this.env.iterator(); it.hasNext(); )
		{
			id = (ident)it.next();
			tmp.add(id.clone());
		}
		
		tab.setEnv(tmp);

		return tab;
	}


	public ArrayList collectIdentLevel(int level)	
	{
		int i;
		ArrayList res = new ArrayList();

		for ( i = 0; i < this.env.size(); i++) {
			ident id = (ident)this.env.get(i);
			if (id.getLevel()<=level) {
				res.add(id);
			}
		}
		return res;
	}

	/** put in the table the identifiers that
	 * occurs in node 
	 * */
        public void collectIdent(CTreeNode node, int level, TAB resultG)
	{
            Object[] ats = new Object[3];
	    CTreeNode[] next;
	    String nodeName;
	    int i = 0;
	    boolean isStruct = false, haveInit = false, isFunc = false;
	    TAB result = new TAB();
	    ArrayList resS = new ArrayList();

            if (node!=null)
	    {
		nodeName = node.getSymbol().getName();
                ats      = node.getAttributes();

		if (nodeName.equals("DECL"))
		{
			// is struct
			if (!node.getNodeAt(0).getSymbol().isTerminal())
			{
				isStruct = true;
			}
			// have initialization
			else if (!node.getNodeAt(1).getSymbol().isTerminal())
			{
				haveInit = true;
			}
			//System.out.println("Colocar na tabela: " + ats[0] + " (VAR) " + level);
			resultG.putTable((String)ats[0],(String)ats[2],"variable",level,(Object)null);
		}
		else if (nodeName.equals("FUNC"))
		{
			//System.out.println("Colocar na tabela: " + ats[0] + " (FUNC) " + level);
			resultG.putTable((String)ats[0],(String)ats[2],"function",level,(Object)null);
			isFunc = true;
		}

		next=(CTreeNode[])node.getNodes();
		if (!isStruct && !haveInit && !isFunc)
		{
			for(i=0; i < next.length; i++) { collectIdent(next[i],level,resultG); }
		}
		else if (isStruct)
		{
			// here, the variable result, should be changed to TAB,
			// to keep the coherence
			processDeclNode(node.getNodeAt(0),level,resS);
			resultG.putLocalTable((String)ats[0],resS.clone());
			resS = new ArrayList();
			isStruct = false;
		}
		else if (isFunc)
		{
			result = new TAB();
			//process the arguments of the function
			processArgsNode(node.getNodeAt(0), level+1, result);
			TAB local = new TAB();
			//System.out.println("ARGS: " + ats[0] + " - " + result + " - " + node.getNodeAt(1));
			//process the variables declared in the function
			collectIdent(node.getNodeAt(1),level+1,local);
			//System.out.println("Result func: " + ats[0] + " " + local.getEnv());

			Hashtable<String, Object> localInfo = new Hashtable<String, Object>();
			if (local == null) { local = new TAB(); }
			if (!isByCopy) {
				localInfo.put("arguments",result);
			}
			else { localInfo.put("arguments",result.clone()); }
			localInfo.put("variables",local.clone());
			localInfo.put("node",node);

			resultG.putLocalTable((String)ats[0],localInfo);

			isFunc   = false; 
		}
	    }
        }

	/** Process the arguments of a function/procedure 
	 * 
	 * @param node   - node to process
	 * @param result - the ArrayList where atomic elements are stored
	 *
	 * @return void 
	 *
	 **/	
        public void processArgsNode(CTreeNode node, int level, TAB result)
	{
           CTreeNode[] next;
	   CTreeNode child;
	   int i=0, index=-1;
	   String nodeName;
	   Object[] ats = new Object[3];

	   if (node!=null)
	   {
		nodeName = node.getSymbol().getName();
                ats      = node.getAttributes();

		// supports two types of declarations of arguments:
		// 1. just CVarNode(name)
		// 2. CDeclNode(name,type,null,null)
		if (nodeName.equals("VAR"))
		{
			result.putTable((String)ats[0],(String)ats[2],"variable",level,(Object)null);
		}

		next=(CTreeNode[])node.getNodes();
		for(i=0; i < next.length; i++) { processArgsNode(next[i],level,result); }
	   }
        }

	/** Process a DeclNode - in case of structs
	 * 
	 * @param node   - node to process
	 * @param result - the ArrayList where atomic elements are saved
	 *
	 * @return void 
	 *
	 **/	
        public void processDeclNode(CTreeNode node, int level,ArrayList result)
	{
           CTreeNode[] next;
	   CTreeNode child;
	   int i=0, index=-1;
	   String nodeName;
	   Object[] ats = new Object[3];

	   if (node!=null)
	   {
		nodeName = node.getSymbol().getName();
                ats      = node.getAttributes();

		if (nodeName.equals("DECL"))
		{
			result.add(new ident((String)ats[0],(String)ats[2],"variable",level,"",false));
		}

		next=(CTreeNode[])node.getNodes();
		for(i=0; i < next.length; i++) { processDeclNode(next[i],level,result); }
	   }
        }

	/** Process an LstNode - in case of be an array of integers,
	 * so you process all terminal elements and they are added to an
	 * ArrayList, that then will be use on identifiers table
	 * 
	 * @param node   - node to process
	 * @param result - the ArrayList where atomic elements are saved
	 *
	 * @return void 
	 *
	 **/	
        public void processLstNode(CTreeNode node, ArrayList result)
	{
           CTreeNode[] children;
	   CTreeNode child;
	   int i=0, index=-1;
	   Object[] ats = new Object[3];

	   if (node instanceof CConstNode)
	   {
		ats = node.getAttributes();
		//System.out.println(ats[0] + " " + ats[1] + " " + ats[2] + "\n");
		result.add(ats[1]);
	   }
	   else
	   {
		children = (CTreeNode[])node.getNodes();
	   	for(i = 0; i < children.length; i++)
		{
			child = (CTreeNode)children[i];
			processLstNode(child,result);
		}
	   }
        }

	/** Add an identifier to table 
	 * @param n - name of identifier
	 * 	  t - type of identifier 
	 * 	  c - class of identifier
	 * 	  v - value of identifer 
	 * 	  p - number of parameters
	 *
	 *  @return void 
	 *
	 *  This method replace a identifier if is duplicated
	 *  otherwise inserts a new identifier (if not duplicated)
	 **/	
        public void putTable(String n,String t,String c,int level,Object v)
	{
            int i=0, index=-1;
	   
	   if (!n.equals("null"))
	    {
		   index = this.getIndexOfIdent(n);
		   if (index==-1) { env.add(new ident(n,t,c,level,v,false));  	      }
		   else { 
			   env.remove(env.get(index));
			   env.add(new ident(n,t,c,level,v,false));  	      
		   }
	    }
        }         

       /** Set a value of a local table of an identifier
	 * @param n     - name of identifier
	 *        child - name of identifier in local table
	 * 	  v     - value of identifer 
	 *
	 *  @return void 
	 *
	 **/	
	public  void  putLocalTable(String  n, String child, Object v){
		int index, index2;
		ident id;

		if (!n.equals("null"))
		{
			index = this.getIndexOfIdent(n);
			if (index!=-1) 
			{ 
				id = (ident)this.env.get(index);	
				TAB aux = new TAB();
				aux.setEnv((ArrayList)((ArrayList)id.getLocalIdentifiers()).clone());
				ident id2 = aux.getIdent(child);
				id2.setValue(v);
				id2.setInitialized(true);
				index2 = aux.getIndexOfIdent(child);
				aux.setIdent(child,id2);
				id.setLocalIdentifiers(aux.getEnv());
				//this.setIdent(n,id);
				//System.out.println(n + " " + child + " " + v + " " + index2 + " " +aux.getIds());
			}
		}
	}

	public  void  changeLocalTable(String  n, String child, Object v){
		int index;
		ident id;

		if (!n.equals("null"))
		{
			index = this.getIndexOfIdent(n);
			if (index!=-1) 
			{ 
				id = (ident)this.env.get(index);	
				TAB aux = new TAB();
				aux.setEnv((ArrayList)((ArrayList)id.getLocalIdentifiers()).clone());
				ident id2 = aux.getIdent(child);
				id2.setValue("10");
				//id2.setInitialized(true);
				//aux.setIdent(child,id2);
				//id.setLocalIdentifiers(aux.getIds());
				this.setIdent(n,id);
				//System.out.println(n + " " + child + " " + v + " " + aux.getEnv());
			}
		}
	}

	 /** Get a value of a local table of an identifier
	 * @param n     - name of identifier
	 *        child - name of identifier in local table
	 * 	  v     - value of identifer 
	 *
	 *  @return void 
	 *
	 **/	
	public  Object  getLocalValue(String  n, String child){
		int index;
		ident id;
		Object v = null;
		
		if (!n.equals("null"))
		{
			index = this.getIndexOfIdent(n);
			if (index!=-1) 
			{ 
				id = (ident)this.env.get(index);	
				TAB aux = new TAB();
				aux.setEnv((ArrayList)((ArrayList)id.getLocalIdentifiers()).clone());
				v = aux.getTable(child);
			}
		}
		return v;
	}

	/** Get a value of a local table of an identifier
	 * @param n     - name of identifier
	 * 	  v     - value of identifer 
	 *
	 *  @return void 
	 *
	 **/	
	public  Object  getLocalValue(String  n){
		int index;
		ident id;
		Object v = null;
		
		if (!n.equals("null"))
		{
			index = this.getIndexOfIdent(n);
			if (index!=-1) 
			{ 
				id = (ident)this.env.get(index);	
				v = id.getLocalIdentifiers();
			}
		}
		return v;
	}

        /** Add a local table to an ident --- used in case of a struct/procedure/function
	 * @param n - name of identifier
	 * 	  v - value of identifer 
	 *
	 *  @return void 
	 *
	 **/	
	public  void  putLocalTable(String  n, CTreeNode node, Object v){
		int index;

		if (!n.equals("null"))
		{
			index = this.getIndexOfIdent(n);
			if (index!=-1) 
			{ 
				ident id = (ident)this.env.get(index);
				id.setLocalIdentifiers(v);	
				id.setValue(node);
				id.setInitialized(true);
			}
		}
	}

        /** Add a local table to an ident --- used in case of a struct/procedure/function
	 * @param n - name of identifier
	 * 	  v - value of identifer 
	 *
	 *  @return void 
	 *
	 **/	
	public  void  putLocalTable(String  n, Object v){
		int index = this.getIndexOfIdent(n);

		if (index!=-1) 
		{ 
			ident id = (ident)this.env.get(index);
			id.setLocalIdentifiers(v);	
		}
	}
	
	/** Index of identifier in environment 
	 *  @param nameOfIdent - name of identifier 
	 *  
	 *  @return j - index of identifier in environment */	
	public int getIndexOfIdent(String nameOfIdent) {
		int i = 0, j = -1;
		ident newIdent;
		
		for (i = 0; i < this.env.size(); i++) {
			newIdent = (ident)this.env.get(i);
			if (nameOfIdent.equals(newIdent.name) && j==-1)
			{
				j = i;
			}
		}

		return j;
	}

	/** Index of identifier in environment 
	 *  @param nameOfIdent - name of identifier 
	 *  
	 *  @return j - index of identifier in environment */	
	public int getLastIndexOfIdent(String nameOfIdent) {
		int i = 0, j = -1, c = this.env.size();
		ident newIdent;
		
		for (i = c-1; i >= 0; i--) {
			newIdent = (ident)this.env.get(i);
			if (nameOfIdent.equals(newIdent.name) && j==-1)
			{
				j = i;
			}
		}

		return j;
	}
	
	
        /** Add an identifier to table 
	 * @param n - name of identifier
	 * 	  v - value of identifer 
	 *
	 *  @return void 
	 *
	 *  This method replace a identifier if is duplicated
	 *  otherwise inserts a new identifier (if not duplicated)
	 **/	
	public  void  putTable(String  n,Object v){
		int index;

		if (!n.equals("null"))
		{
			index = this.getLastIndexOfIdent(n);
			if (index!=-1) 
			{ 
				ident id = (ident)this.env.get(index);
				id.setValue(v);	
				//System.out.println("\n\nTAB put: " + n + ", index: " + index + " value: " + v);
				id.setInitialized(true);					
			}
		}
	}
              
 
       /** Gets id in environment */	
        public ident getIdent(String n){
            int index, i;
	    ident newIdent;
	    
	    index = this.getIndexOfIdent(n);
	    newIdent = (ident)((ident)env.get(index)).clone(); 
            
            return newIdent;
        }

	/** Sets id in environment */	
        public void setIdent(String n, ident newId){
            int index;
	    
	    index = this.getIndexOfIdent(n);
	    this.env.set(index,newId);
        }
	
       /** Gets value of a identifier in environment */	
        public Object getTable(String n){
            int index, i;
	    Object value = null;
	    ident newIdent;
	    //System.out.println("1.");
	    index = this.getIndexOfIdent(n);
        //System.out.println("IND->"+ index);
	    if (index!=-1) {
            //System.out.println("3.if");
            //System.out.println("Value of " + n + value);
		    value = ((ident) env.get(index)).getValue(); 
            //System.out.println("4.if");
        }
        
		    //System.out.println("\n\nTAB get: " + n + " , index: " + index + " value: " + value);
            
            return value;
        }

	/** Gets type of a identifier in environment */	
        public String getType(String n){
            int index, i;
	    String type = new String();
	    ident newIdent;
	    
	    index = this.getIndexOfIdent(n);

	    if (index!=-1) { type = ((ident) env.get(index)).getType(); }
            
            return type;
        }

	// Print identifiers in table	
        public void  print(){
		int i;

		for(i=0; i<env.size();i++) { System.out.println(((ident)(env.get(i))).toString());  }
        }   


}
