package Alma;

import java.util.ArrayList;
import java.awt.Point;
import Lisa.Parser.CTreeNode;


public class Table
{
	/* ids to populate table */
	private ArrayList table;
	/* indicate the state to color with red -- node that will be evaluated */
	private int stateBefore;
	/* indicate the state to color with green -- node already evaluated */
	private int stateNext;
	/* node that is currently being evaluated -- used in case of READ statement */
	private CTreeNode node;
	/* structure to save relations between node and its child and sibling */
	private CParentNode all;
	/* ArrayList -- in case of variables of type array */
	private ArrayList arrayValues;
	/* indicate the row in source program to color with red -- row that will be evaluated */
	private int row;
	/* indicate the position of the current node to be evaluated */
	Point position;

	public Table()
	{
		this.table       = new ArrayList();
		this.stateBefore = 0;
		this.stateNext   = 0;
		this.position    = new Point();
		this.row         = -1;
		this.node        = null;
		this.all	 = null;
		this.arrayValues = new ArrayList();
	}
	
	public Table(ArrayList table, int b, int n, int r, Point p, CTreeNode node, CParentNode all)
	{
		this.table       = (ArrayList)table.clone();
		this.stateBefore = b;
		this.stateNext   = n;
		this.row	 = r;
		this.position    = p;
		this.node        = node;
		this.all	 = all;
	}

	public ArrayList getTable()
	{
		return this.table;
	}

	public int getBefore()
	{
		return this.stateBefore;
	}

	public int getNext()
	{
		return this.stateNext;
	}

	public int getRow()
	{
		return this.row;
	}

	public CTreeNode getNode()
	{
		return this.node;
	}

	public CParentNode getAll()
	{
		return this.all;
	}

	public Point getPosition() {
		return this.position;
	}

	public String toString()
	{
		return (this.table.toString()+ " ROW: " + this.row + " NODE: " + this.node.toString() + " " + this.stateBefore + " " + this.stateNext);
	}

	public ArrayList getArrayValues()
	{
		return this.arrayValues;
	}

	/** Sets information */

	public void setTable(ArrayList table)
	{
		this.table = (ArrayList)table.clone();
	}
	
	public void setBefore(int before)
	{
		this.stateBefore = before;
	}

	public void setNext(int next)
	{
		this.stateNext = next;
	}

	public void setNode(CTreeNode node)
	{
		this.node = node;
	}

	public void setAll(CParentNode all)
	{
		this.all = all;
	}

	public void setArrayValues(ArrayList values)
	{
		this.arrayValues = (ArrayList)values.clone();
	}
}
