package Alma;

// "Java Tech"
//  Code provided with book for educational purposes only.
//  No warranty or guarantee implied.
//  This code freely available. No copyright claimed.
//  2003
//

import java.awt.*;
import javax.swing.*;

/**
  * This JPanel subclass holds a JTextArea object in a
  * JScrollPane area. The scrollpane will automatically
  * display vertical and horizontal scroll bars if the
  * text goes beyond the frame areas in vertical and
  * horizontal dimensions.<br>
  *
  * This class also implements our Outputable interface
  * that provides print(String) and println(String) methods
  * similar to those in System.out.
 **/
public class TextOutputPanel extends JPanel
                  implements Outputable
{
  // A Swing textarea for display of string info
  JTextArea fTextArea = null;

  public TextOutputPanel () {

    // A BorderLayout would be more appropriate here but
    // it isn't discussed until chapter 7.
    setLayout (new GridLayout (1,1));

    // Create an instance of JTextArea
    fTextArea = new JTextArea ();
    fTextArea.setEditable (false);

    // Add to a scroll pane so that a long list of
    // computations can be seen.
    JScrollPane area_scroll_pane = new JScrollPane (fTextArea);

    add (area_scroll_pane);
  }

  /** Display a string + carriage return on the JTextArea. **/
  public void println(String str) {
    fTextArea.append(str + CR);
  }

  /** Dispaly a string on the JTextArea. **/
  public void print(String str) {
    fTextArea.append(str);
  }

}// class TextOutputPanel
