package Alma;

import  java.util.ArrayList;
import  java.util.Hashtable;

import  java.awt.Color;
import  java.awt.Point;

import  Lisa.Parser.CTreeNode;

import  org.jgraph.graph.DefaultGraphCell;
import  org.jgraph.graph.DefaultEdge;

public class Visualize
{
	private Graph graph;
	private int level;
	private CParentNode p;
	private TAB tab;
	private Hashtable types;

	public Visualize(Graph graph)
	{
		this.graph = graph;
		this.level = 0;
		this.p     = null;
		this.tab   = new TAB();
		this.types = new Hashtable();
	}

	public void initLevel()
	{
		this.level = 0;
	}

	public void setParent(CParentNode p1)
	{
		this.p = p1;
	}

	public void setTypes(Hashtable t) 
	{
		this.types = t;
	}

	public void setTAB(TAB tab)
	{
		this.tab = tab;
	}
	/**
	 * Collect vertices that were draw in structure CParentNode
	 * */
	public void makeConnect(CParentNode t, ArrayList cells)
	{
		DefaultEdge edge = new DefaultEdge();
		DefaultGraphCell cell, cell2;
		CParentNode node;
		CTreeNode n1, child, parent, parentChild;
		int x, y, width, height, level, level2;
		String name, label, name2;
		boolean isWrite = false, isStruct = false;

		if (t != null)
		{
			n1   = (CTreeNode)t.getLabel();
			name = n1.getSymbol().getName();

			if (!t.getHiden())
			{
				if (t.haveChild())
				{
					child = (CTreeNode)t.getChild().getLabel();
	                                name2 = child.getSymbol().getName();
						
					if (!t.getChild().getHiden())
					{
						edge = new DefaultEdge();
						edge.setSource(((DefaultGraphCell)cells.get(t.getLevel())).getChildAt(0));
						edge.setTarget(((DefaultGraphCell)cells.get(t.getChild().getLevel())).getChildAt(0));
								cells.add(edge);
						}
					}
					if (t.haveChildSibling())
					{
						child = (CTreeNode)t.getChild().getSibling().getLabel();
						name  = child.getSymbol().getName();
						
						if (!t.getChild().getSibling().getHiden())
						{
							edge = new DefaultEdge();
							edge.setSource(((DefaultGraphCell)cells.get(t.getLevel())).getChildAt(0));
							edge.setTarget(((DefaultGraphCell)cells.get(
							t.getChild().getSibling().getLevel())).getChildAt(0));
							// add the connection
							cells.add(edge);
						}
					}

					if (t.haveSecondSibling() && 
							!t.getChild().getSibling().getSibling().getHiden()) {
						child = (CTreeNode)t.getChild().getSibling().getSibling().getLabel();
						name  = child.getSymbol().getName();
						
						edge = new DefaultEdge();
						edge.setSource(((DefaultGraphCell)cells.get(t.getLevel())).getChildAt(0));
						edge.setTarget(((DefaultGraphCell)cells.get(
						t.getChild().getSibling().getSibling().getLevel())).getChildAt(0));
						// add the connection
						cells.add(edge);
					}
				makeConnect(t.getChild(),cells);
				makeConnect(t.getSibling(),cells);
			}
			// in case of step of evaluation
			else
			{
				// if is a assign then we save the child of current vertice (that is "=")
				// because there was the variable that was updated
				// in case of node be an oper/operrel/... then we save the current vertice
				if (name.equals("ASSIGN") || name.equals("WRITE") || name.equals("READ"))
				{
					node = t.getChild();
				}
				else
				{
					node = t;
				}

				//System.out.println("Pai: " + t.getParent().getLabel());
				String name3 = ((CTreeNode)node.getLabel()).getSymbol().getName();
			//	if (!name3.equals("FUNC")) {

					level  = getLevel(this.p, (CTreeNode)t.getParent().getLabel());
					level2 = getLevel(this.p, (CTreeNode)node.getLabel());
					edge = new DefaultEdge();	
					edge.setSource(((DefaultGraphCell)cells.get(level)).getChildAt(0));
					edge.setTarget(((DefaultGraphCell)cells.get(level2)).getChildAt(0));
					cells.add(edge);				
			//	}
				makeConnect(t.getSibling(),cells);
			}
		}
	}

	public void print(CParentNode t)
	{
		if (t != null)
		{
			System.out.println("__" + t.getLabel());			
			print(t.getChild());
			print(t.getSibling());
		}
	}
	
	public int getLevel(CParentNode p, CTreeNode n)
	{
		if (p!=null)
		{
			if (p.getLabel().toString().equals(n.toString()))
			{
				level = p.getLevel();
			}
			else
			{
				getLevel(p.getChild(),n);
				getLevel(p.getSibling(),n);
			}
		}
		return level;
	}
	
	/**
	 * Collect vertices that were draw in structure CParentNode
	 * */
	public void createCells(CParentNode t, ArrayList cells)
	{
		DefaultEdge edge = new DefaultEdge();
		DefaultGraphCell cell, cell2;
		CParentNode node;
		CTreeNode n1, parent, parentChild;
		int x, y, width, height;
		String name, label;
		boolean isWrite = false, isStruct = false;

		if (t != null)
		{
			n1   = (CTreeNode)t.getLabel();
			name = n1.getSymbol().getName();

			if (!t.getHiden())
			{
				cell = (DefaultGraphCell)t.getVertice().clone();
				cell.addPort();
				cells.add(cell);
				t.setLevel(level);
				level++;

				createCells(t.getChild(),cells);
				createCells(t.getSibling(),cells);
			}
			else
			{
				// if is a assign then we save the child of current vertice (that is "=")
				// because there was the variable that was updated
				// in case of node be an oper/operrel/... then we save the current vertice
				if (name.equals("ASSIGN"))
				{
					cell = (DefaultGraphCell)t.getChild().getVertice().clone();	
					node = t.getChild();
				}
				else if (name.equals("WRITE"))
				{
					cell    = (DefaultGraphCell)t.getChild().getVertice().clone();	
					node    = t.getChild();
					isWrite = true;
				}	
				else if (name.equals("READ"))
				{
					cell    = (DefaultGraphCell)t.getChild().getVertice().clone();	
					node    = t.getChild();
				}	
				else
				{
					cell = (DefaultGraphCell)t.getVertice().clone();
					node = t;

				}

				x      = t.getPosition().x;
				y      = t.getPosition().y;
				width  = node.getWidth();
				height = node.getHeight();
	
				if (isWrite)
				{
					cell = graph.createEllipse(t.getChild().getValue().toString(),
							      x-10, y, 75, 40, Color.GREEN, false);
					cell.addPort();
					cells.add(cell);
					t.getChild().setLevel(level);
					level++;
				}
				else
				{
					cell.addPort();
					graph.changeBounds(cell, x, y ,width, height);
					cells.add(cell);
					node.setLevel(level);
					level++;
				}
				
				createCells(t.getSibling(),cells);
			}
		}
	}

	
	/**
	 * change color of the vertices that will be evaluated
	 * */
	public void changeColorCell(CParentNode t, String node, Color c)
	{
		CTreeNode n;
		DefaultGraphCell cell;
		int x, y, width, height;
		
		if (t != null)
		{
			if (t.getLabel().toString().equals(node))
			{
                //System.out.println(">>>"+t.getLabel().toString());
				// this test is because of while
				// in case of condition already evaluated
				// and will be again evaluated
                //System.out.println("t.getHiden: "+t.getHiden());
				if (t.getHiden() && (c == Color.RED))
				{
                    //System.out.println(" t.getParent: " + t.getParent());
                    //System.out.println(" t.getParent.getHiden: " + t.getParent().getHiden());
					if (t.getParent().getHiden())
						t.getParent().setHiden(false);

                    n = (CTreeNode)t.getLabel();
					t.setVertice(graph.createRectangle(n.getAttributes()[0].toString(),
						     t.getPosition().x,t.getPosition().y,t.getWidth(),t.getHeight(),Color.RED,false));
					t.setHiden(false);

                    //System.out.println(" t.getChild " + t.getChild());
					if (t.getChild() != null)
					{
						t.getChild().setHiden(false);
					}
					if (t.getChild() != null && t.getChild().getSibling() != null)
					{
						t.getChild().getSibling().setHiden(false);
					}
				}

                //System.out.println("..."+t.getLabel().toString());
				graph.changeColor(t.getVertice(),c);
				if (t.getChild() != null)
				{
					graph.changeColor(t.getChild().getVertice(),c);
				}
				if (t.getChild() != null)
				{
					if (t.getChild().getSibling() != null)
					{
						graph.changeColor(t.getChild().getSibling().getVertice(),c);
					}
				}
			}
			else
			{
                changeColorCell(t.getChild(),node,c);
				changeColorCell(t.getSibling(),node,c);
			}
		}
	}

	public void createVertex(CParentNode t, boolean isLocal, String title)
	{
		ArrayList  rules = new  ArrayList();
                boolean  found;
		int i, np, width, height;
		Object[] attributes;		
		CTreeNode node;
		CAlmaNode child;
		Point pos;
		String name, label = new String(), type, typeTable;
		DefaultGraphCell cell;
		
		if (t != null)
		{
			node       = (CTreeNode)t.getLabel();
			name       = node.getSymbol().getName();
	                attributes = node.getAttributes();		
		        pos        = t.getPosition();
		     	width      = t.getWidth();
		        height     = t.getHeight();

			if (name.equals("STATS"))
			{
				// means that is the root of our program
				if (t.getParent() == null)
				{
					if (isLocal) // then we have a local initialization (and its a struct)
					{
						cell = graph.createRectangle(title,pos.x,pos.y,65,20,null,false);
					}
					else {	cell = graph.createRectangle("Program",pos.x,pos.y,65,20,null,false);	}
					t.setVertice(cell);
				}
				// else is/are statement(s)
				else
				{
					cell = graph.createRectangle("Statements",pos.x,pos.y,80,20,null,false);
					t.setVertice(cell);
                    //System.out.println("----- SATEMENTS -------");
				}
			}
			else
			{
				if (name.equals("IF") | name.equals("WHILE") || name.equals("WRITE") || name.equals("READ"))
				{
					cell = graph.createRectangle(name,pos.x,pos.y,45,20,null,false);
					t.setVertice(cell);
				}
				else if (name.equals("ASSIGN") )
				{
					CAlmaNode n = (CAlmaNode)node;
					child = (CAlmaNode)node.getNodeAt(0);
					type = this.tab.getType(child.getName());
					typeTable  = (this.types.containsKey(type)) ? ((String)this.types.get(type)) : type;

					label = " = ";	
					if (n.getType().equals("ARRAY_OR_STRUCT"))
					{
						if (typeTable.equals("array"))	{ label = "[]";	}
						else if (typeTable.equals("struct")) { label = ".";	}
					}
                    //System.out.println("-- label " + label);
					t.setVertice(graph.createRectangle(label,pos.x,pos.y,width,height,Color.GRAY,false));
				}
				else if (name.equals("OPER") || name.equals("OPERREL"))
				{
				     Alma.CAlmaNode n = (Alma.CAlmaNode)node;
				     
			     	     label      = n.getName();
				     t.setVertice(graph.createRectangle(label,pos.x,pos.y,width,height,Color.GRAY,false));
				}
				else if (name.equals("FUNC"))
				{
				     Alma.CAlmaNode n = (Alma.CAlmaNode)node;	
     				     t.setVertice(graph.createRectangle("Func: " + n.getName(),
							     pos.x,pos.y,width,height,Color.GRAY,false));
				}
				else if (name.equals("CALL"))
				{
				     Alma.CAlmaNode n = (Alma.CAlmaNode)node;	
     				     t.setVertice(graph.createRectangle("Call: " + n.getName(),
							     pos.x,pos.y,width,height,Color.GRAY,false));
				}
				else if (name.equals("RETURN"))
				{
     				     t.setVertice(graph.createRectangle("Return", pos.x,pos.y,width,height,Color.GRAY,false));
				}
				else if (!name.equals("null"))
				{
				     Alma.CAlmaNode n = (Alma.CAlmaNode)node;
				     label            = n.getValue().toString();

				     if (name.equals("CONST"))
				     {
					label = "Constant: " + label;
				     }
				     else if (name.equals("VAR"))
				     {
					     if (label.equals("null"))
					     {
						    label = "<html>Name: " + 
							     n.getName() + 
							     "<br>Value: </html>";
					     }
					     else
					     {
						     label = n.getName() + 
							     " (Value: " + 
							     label + ")";
					     }
				     }
				     else if (name.equals("LST"))
				     {
					     ArrayList result = new ArrayList();
					     processLstNode(node,result);					     
					    
					     if (label.equals("null")) { label = "Value: " + result; }
					     else {  label = "Value: []"; }
					     // to compute all childs but its visualization it is optional
					     t.setHiden(true);
	      			     }
				     else if (name.equals("null"))
				     {
	      			     }
     				     t.setVertice(graph.createRectangle(label,pos.x,pos.y,width,height,Color.GRAY,false));
				}
			}
			createVertex(t.getChild(),false,title);
			createVertex(t.getSibling(),false,title);
		}
	}

	/** Process an LstNode - in case of be an array of integers,
	 * so you process all terminal elements and they are added to an
	 * ArrayList, that then will be use on identifiers table
	 * 
	 * @param node   - node to process
	 * @param result - the ArrayList where atomic elements are saved
	 *
	 * @return void 
	 *
	 **/	
        public void processLstNode(CTreeNode node, ArrayList result)
	{
           CTreeNode[] children;
	   CTreeNode child;
	   int i=0, index=-1;
	   Object[] ats = new Object[3];

	   if (node instanceof CConstNode)
	   {
		ats = node.getAttributes();
		result.add(ats[1]);
	   }
	   else
	   {
		children = (CTreeNode[])node.getNodes();
	   	for(i = 0; i < children.length; i++)
		{
			child = (CTreeNode)children[i];
			processLstNode(child,result);
		}
	   }
        }
}
