/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package Alma.animation;

import Alma.animation.patterns.AnimationPattern;
import java.awt.image.BufferedImage;
import java.io.File;
import java.util.ArrayList;
import javax.imageio.ImageIO;

/**
 *
 * @author Nuno Oliveira
 */
public class Utilities {

    /**
     *
     * @param ref The path to the image
     * @return The image correspondent to the file
     */
    public static BufferedImage loadImage(String ref) {  
        BufferedImage bimg = null;
        try {

            bimg = ImageIO.read(new File(ref));
        } catch (Exception e) {
            e.printStackTrace();
        }
        return bimg;
    }


    /**
     * 
     * @param aps A list of AnimationPatterns
     * @return ArrayList of animationPatterns
     */
    public static ArrayList<AnimationPattern> toArrayListAP(AnimationPattern[] aps){

        ArrayList<AnimationPattern> a = new ArrayList<AnimationPattern>();
        for(AnimationPattern ap : aps){
            a.add(ap);
        }
        return a;
    }

    /**
     *
     * @param acs A list of AnimationPatterns
     * @return ArrayList of animationPatterns
     */
    public static ArrayList<Actor> toArrayListActor(Actor[] acs){

        ArrayList<Actor> a = new ArrayList<Actor>();
        for(Actor ac : acs){
            a.add(ac);
        }
        return a;
    }

    
}
