/*
 * Pattern to Rotate an object over itself in a bi-dimensional space
 */

package Alma.animation.patterns;

import Alma.animation.*;

/**
 *
 * @author Nuno Oliveira
 */
public class APRotate extends AnimationPattern{

    //stores the angle of rotation of the actor
    private int rotAngle;
    //says whether it is needed to get the angle value from the id tablE
    private boolean needEvaluation;
    //stores the name of the variable to access the value of the angle in the actor's state.
    private String vAngle;
    
    /**
     * @param obj the object that is to be animated
     * @param rotAngle the new angle for the object
     */
    public APRotate(Actor obj, int[] poses, int rotAngle) {
        super(obj, poses);
        this.rotAngle = rotAngle;
        this.needEvaluation = false;
        this.setIsAggregator(false);
    }

    public APRotate(Actor obj, int[] poses, String angleVar) {
        super(obj,poses);
        this.vAngle = angleVar;
        this.needEvaluation = true;
        this.setIsAggregator(false);
    }




    public int getRotAngle() {
        return rotAngle;
    }

    public void setRotAngle(int rotAngle) {
        this.rotAngle = rotAngle;
    }
    
    

    @Override
    public void animate() {
        if(needEvaluation){
            this.rotAngle = (Integer)this.getValue(this.vAngle);
        }

        Actor o = this.getObj();
        o.setAngle(rotAngle);
        o.setUsedPoses(this.getPoses());
    }
    
    
    

}
