package Alma;

import java.util.ArrayList;

public class ident {
	/** tha name, the type and the class - function, variable, ...) of the variable **/
    public String name, type, classIdent;
    	/** tha value and possible the set of local variables -- in case of structured data types
	 * or functions **/
    public Object value, localIdent;
    	/** if the variable is already initialized **/
    public boolean initialized;
    	/** and the level that the variable appears - 0 (global)
	 * and successors in case of functions **/
    private int level;
    
    public ident(String n, String t, String classI, int level1, Object val, boolean init) {
        this.name        = n;
        this.type        = t;
	this.classIdent  = classI;
	this.level       = level1;
        this.value       = val;
	this.localIdent  = null;
	this.initialized = init;
    }

    public ident(String n, String t, String classI, int level1, Object val, Object local, boolean init) {
        this.name        = n;
        this.type        = t;
	this.classIdent  = classI;
	this.level       = level1;
        this.value       = val;
	this.localIdent  = local;
	this.initialized = init;
    }
    
    /** clone a ident */
    public Object clone()
    {
	    ArrayList copy = new ArrayList();
	    ident id;
	    
	    if ((this.localIdent != null) && (this.localIdent instanceof ArrayList))
	    {
		    copy = (ArrayList)this.localIdent;
		    copy = (ArrayList)copy.clone();
		    id = new ident(new String(this.name),new String(this.type), new String(this.classIdent), this.level,
				    this.value,copy,this.initialized);
	    }
	    else { id = new ident(new String(this.name),new String(this.type), new String(this.classIdent), this.level,
			    this.value,this.localIdent,this.initialized); }
	    return id;
    }

    /** clone a ident --- second version (copy all but not the values) */
    public Object cloneSnd()
    {
	    ArrayList copy = new ArrayList();
	    ident id;
	    
	    if ((this.localIdent != null) && (this.localIdent instanceof ArrayList))
	    {
		    copy = (ArrayList)this.localIdent;
		    copy = (ArrayList)copy.clone();
		    id = new ident(new String(this.name),new String(this.type), new String(this.classIdent), this.level,
				    null,copy,false);
	    }
	    else { id = new ident(new String(this.name),new String(this.type), new String(this.classIdent), this.level,
			    null,this.localIdent,false); }
	    return id;
    }

    
    /** Returns name of identifier */
    public String getName() {
	    return this.name;
    }
   
    /** Returns type of identifier */
    public String getType() {
	    return this.type;
    }

    /** Returns type of identifier */
    public String getClassIdent() {
	    return this.classIdent;
    }

    /** Returns value of identifier */
    public Object getValue() {
	    return this.value;
    }

    /** Returns level of identifier */
    public int getLevel() {
	    return this.level;
    }

    /** Returns if the variable is already initialized */
    public boolean isInitialized() {
	    return this.initialized;
    }

   
    /** Returns local identifiers --- usually used with 
     * struct and functions/procedures 
     * */
    public Object getLocalIdentifiers() {
	    return this.localIdent;
    }
    
    /** Set local identifiers **/
    public void setLocalIdentifiers(Object local) {
	    if (local instanceof ArrayList)
	    {
		    this.localIdent = ((ArrayList)local).clone();
	    }
	    else {  this.localIdent = local;	}
    }
    
    /** Sets value of identifier */
    public void setValue(Object newValue) {
	    this.value = newValue;
    }

    /** Sets value of initialized */
    public void setInitialized(boolean init) {
	    this.initialized = init;
    }
    
    public String toString(){
	String res = "Name: " + this.name + " " +
		     "Type: " + this.type + " " +
		     "Class: " + this.classIdent + " " +
		     "Level: " + this.level + " " +
		     " Value:" + this.value + " ";
	res += "\n\tLocal info: " + this.localIdent + "\n";
	return res;
    }
}
