//Lisa 2.0  
//Laboratory for Computer Arhitectures and Programming Languages 
// %n is special string
// n = 0 inserts classname
// n = 1 inserts edges
// n = 2 inserts final state  type table
// n = 3 inserts final state names
// n = 4 start state of automata
// n = 5 max state of automata
// n = 6 vstavi alternative pricakuje pa argumente prv sledi takjo drugi se loci z %
// n = 7 -2 args vstavi semanticne funkcije prvi argument je predpona oz besedilo, ki se doda pored funkcijo (zradi prenosljivosti med java in C++
// n = 8  inserts final state types (all types)
// n = X najvecje stanje v avtomatu
// n = Y subscanner
// n = A begin of the nested scnner
// n = B end of nested scanner
// n = 0 inserst final constants for types 

import java.io.*;
import java.util.*;
import java.lang.*;
import Lisa.Scanner.CToken;
import Lisa.Scanner.LexicalAnalysis;
import Lisa.Scanner.ScannerAutomata;



public class CScanner implements LexicalAnalysis,ScannerAutomata
{

   public CScanner(InputStream aStream, String aStreamName) throws Exception
	 {
		stream = new BufferedInputStream(aStream);
		row = 1;
		column = 1;
		tokenRow = 1;
		tokenColumn = 1;		
		readNextChar();
		streamName = aStreamName;
                automatas.put("default", new _default());

                setScanner("default");
           }

   public void setScanner(String aName)
    {
        cscanner = automatas.get(aName);
        System.out.println("Switching to "+aName);
    }

   private int readNextChar()
	 {
	   	 int read=-1;

	     try
		  {
			 read = stream.read();
			 if (read==-1)
			   {
				  eof = true;
			   }
			 currentChar = read;
		  }
		
		catch (Exception exception)
		  {
			 eof = true;
		  }
		
		column++;
		if (currentChar=='\n') 
		  {
			 row++;
			 column = 0;
		  }
	   return read;	
	 }
   
private void mark()
	 {
		stream.mark(65535);
		backChar = currentChar;
		backRow = row;
		backColumn = column;
		lastEOF = eof;
	 }
   
   private void reset()
	 {
	   try
		  {
			 stream.reset();
		  }
		
		catch (IOException exception)
		  {
			 System.out.println("Prevec naprej");
		  }
		currentChar = backChar;
		row = backRow;
		column = backColumn;
		eof = lastEOF;
	 }
   
   

   private BufferedInputStream stream = null;
   private int column;
   private int row;
   private int tokenColumn;
   private int tokenRow;
   private boolean eof = false;
   private int currentChar; /* uporablja se ker ne obstaja metoda peek */
   private int backChar;
   private int backRow;
   private int backColumn;
   public static final int cLexError = -1;
   private String streamName;
   private boolean lastEOF;
   private Hashtable automatas = new Hashtable();
   
   private Object cscanner;

   public int getCategoryId(String aName)
   {
      for (int i=0; i<=8; i++)
	         {
		    if (aName.equals(finiteStateNameAll[i]))
		      return i;
		 }
      return -1;
   }

   public String getCategoryName(int aType)
   {
        if (aType ==-1) return "";
	else return finiteStateNameAll[aType];    
   }

   public CToken nextToken()
    {
        return ((LexicalAnalysis)cscanner).nextToken();
    }

   public CToken currentToken()
    {
        return ((LexicalAnalysis)cscanner).currentToken();
    }

    public int getStartState()
    {
            return ((ScannerAutomata)cscanner).getStartState();
    }
   
    public CToken peekToken(int k)
     {
        return ((LexicalAnalysis)cscanner).peekToken(k);
     }

     public CToken lexError(CToken aToken) {
         return ((LexicalAnalysis)cscanner).lexError(aToken);
     }

    public int scanLine(int aStartState, String aLine, Vector aTokens)
    {
        return ((LexicalAnalysis)cscanner).scanLine(aStartState,aLine,aTokens);
    }

    public CToken extend(String aToken)
    {
           return ((LexicalAnalysis)cscanner).extend(aToken);
    }

    public int maxCategoryId() {
        return ((LexicalAnalysis)cscanner).maxCategoryId();
    }

    public int getEdge(int aState, int aChar) throws Lisa.Scanner.AutomataException
    {
            return ((ScannerAutomata)cscanner).getEdge(aState, aChar);
    }
 

    public int getFiniteStateType(int aState)
    {
         return ((ScannerAutomata)cscanner).getFiniteStateType(aState);
    }
       
    public Vector getFiniteVector(int aState)
    {
        return ((ScannerAutomata)cscanner).getFiniteVector(aState);
    }
 

public class _default
 implements LexicalAnalysis,ScannerAutomata
{
        
   public static final int cLavanda$Body = 1;
   public static final int cLavanda$House = 2;
   public static final int cLavanda$Identifier = 3;
   public static final int cLavanda$separa = 4;
   public static final int cLavanda$Number = 5;
   public static final int cLavanda$Date = 6;
   public static final int cLavanda$ReservedWords = 7;
   public static final int cLavanda$ignore = 8;   
        
        public _default
() {
                tokens = new Vector();
		for (int i=0; i<=42; i++)
		{
		  Vector Temp = new Vector();
		  finiteStateTypes[i] = Temp;
		  for (int j = 0; j<allStateTypes[i].length; j++)
		    {
		      Temp.addElement(new Integer(allStateTypes[i][j]));
		    }
		  
		}
	 }

   public int getCategoryId(String aName)
	 {
	        for (int i=0; i<=42; i++)
	         {
		    if (aName.equals(finiteStateName[i]))
		      return i;
		 }
	        return -1;
	 }
   
      public String getCategoryName(int aType)
	 {
	        if (aType ==-1) return "";
		else return finiteStateName[aType];
	 }

         
   
   public int getStartState()
   {
    return 0;
   }

   public CToken nextToken()
	 {
		CToken Token = null;
		
		if (tokens.size()>0) 
		  {
			 lastToken = Token = (CToken)tokens.elementAt(0);
			 tokens.removeElementAt(0);
		  }
		else
		  lastToken = readNextToken();
		return lastToken;
		
	 }
   
   public CToken currentToken()
	 {
		return lastToken;
	 }
   
   public CToken peekToken(int k)
	 {
		if (k==0) return lastToken;
		while (tokens.size()< k) tokens.addElement(readNextToken());
		return (CToken)tokens.elementAt(k-1);
	 }
 public int getFiniteStateType(int aState)
    {
	   return finiteStateType[aState];
	}
       
   public Vector getFiniteVector(int aState)
    {
	   return finiteStateTypes[aState];
    }

   public int getEdge(int aState, int aChar)
     {
	    if (aChar==-1) return cLexError;
	    int min = edges[aState][0];
		int max = edges[aState][1];
		if (aChar<min || aChar>max)
		  {
		     if (aChar<min) return edges[aState][2];
			 else return edges[aState][3];
		  }
		else
		  {
		    return edges[aState][aChar-min+4];
		  }
     }
   

 private CToken readNextToken()
     {
	CToken token=readNextTokenImp();
	do
	  {
	     if (token.type()==0)
	       {
		  while ((token=readNextTokenImp()).type()==0 && !token.isEOF());
		  if (token.type()==0)
		    {
		       return new CToken(token.isEOF(), token.row(), token.column(), token.fileName());
		    }
	       }
	     switch (token.type()) 
	       {
		  
		default:
		  ;
	       }
	  }
	while (token.type()==0);
	return token;
     }
   private char token[]= new char[200];

   private CToken readNextTokenImp()
     {
	int CurrentState = 0; // automata start state
	int NewState = cLexError;
	int LastState = 0;
	int TokenColumn = column;
	int TokenRow = row;
	int CurrentPosition = 0;
	int LastPosition = -1;
	NewState = getEdge(CurrentState, currentChar);
	do
	  {

	     if (NewState==-1)
	       {
		  int Type;
		  if ((Type =finiteStateType[CurrentState])==-1)
		    {
		       Type = finiteStateType[LastState];
		       if (Type==-1)
			 return new CToken(eof,TokenRow,TokenColumn,streamName );
		       else
			 {
			    CurrentState = LastState;
			    reset();
			    return new CToken(new String(token,0,LastPosition),Type,TokenColumn,TokenRow,LastPosition==0,currentChar==-1, finiteStateName[Type],CurrentState, streamName, finiteStateTypes[CurrentState]);
			 }
		    }
		  else
		    {
		       return new CToken(new String(token,0,CurrentPosition),Type,TokenColumn,TokenRow,CurrentPosition==0,currentChar==-1, finiteStateName[Type],CurrentState, streamName, finiteStateTypes[CurrentState]);
		    }
	       }
	     else
	       {
		  if (CurrentPosition>=token.length)
		    {
		       char temp[] = new char[CurrentPosition*2];
		       System.arraycopy(token,0,temp,0, token.length);
		       token = temp;
		    }
		  token[CurrentPosition++] = (char)currentChar;
		  readNextChar();
		  CurrentState = NewState;

		  NewState = getEdge(CurrentState, currentChar);
		  if (NewState==cLexError || finiteStateType[NewState]==-1)
		    {
		       if (finiteStateType[CurrentState]!=-1)
			 {
			    mark();
			    LastPosition = CurrentPosition;
			    LastState = CurrentState;
			 }
		    }
	       }
	  }
	while (true);
     }
   
   
   public CToken lexError(CToken aToken)
	 {
		return new CToken(aToken.value(), cLexError, aToken.row(), aToken.column(),
						  aToken.isEmpty(), aToken.isEOF(), aToken.name(), aToken.state(), aToken.fileName(),aToken.types());
	 }
   
      public int scanLine(int aStartState, String aLine, Vector aTokens)
     {
	int CurrentState = aStartState;
	int NewState=0, LastType=-1;
	Vector LastTypes = new Vector();
	int LastPos = 0, LastTokenPos = 0, CurrentPos = 0;
	while (CurrentPos <aLine.length() )
	  {
	     NewState = getEdge(CurrentState,aLine.charAt(CurrentPos));
	     if (NewState == -1)
	       {
		  int Type = finiteStateType[CurrentState];
		  Vector Types = finiteStateTypes[CurrentState];
		  if (Type == -1)
		    {
		       Type = LastType;
		       Types = LastTypes;
		       CurrentPos = LastPos;
		    }
		  if (LastTokenPos == CurrentPos) CurrentPos++; //v primeru leksikalne napake moramo tudi nekaj skozi poslat drugace se zazankamo
		  
		  CToken Token = new CToken(aLine.substring(LastTokenPos,CurrentPos),
					    Type,
					    LastTokenPos,
					    0,
					    false,
					    false,
					    "",
					    CurrentState,
					    "",
					    Types);
		  aTokens.addElement(Token);
		  LastTokenPos = CurrentPos;
		  NewState = 0; //%%%%%%
		  LastType = -1;
		  LastTypes = new Vector();
		  LastPos = CurrentPos;
	       }
	     else
	       {
		  if (finiteStateType[CurrentState]!=-1)
		    {
		       LastType = finiteStateType[CurrentState];
		       LastTypes = finiteStateTypes[CurrentState];
		       LastPos = CurrentPos;
		    }
		  CurrentPos++;
	       }
	     CurrentState = NewState;
	  }
	if (LastTokenPos!=CurrentPos)
	  {
	     CToken EToken = new CToken(aLine.substring(LastTokenPos,CurrentPos),
					finiteStateType[CurrentState],
					LastTokenPos,
					0,
					false,
					true,
					"",
										CurrentState,
					"",
					finiteStateTypes[CurrentState]);
	     aTokens.addElement(EToken);
	  }
	if (finiteStateType[CurrentState]!=-1)
	  CurrentState = 0;
	return CurrentState;
     }
   

   public CToken extend(String aToken)
   {
      System.out.println("Unimplemented feature 'extend'!");
      return null;
   }

   private void resetAutomata()
   {
     LastCurrent = 0;
	 NewState = 0;
   }

   		
   private void print(String aString)
	 {
		System.out.print(aString);
		System.out.flush();
	 }
	
	public int maxCategoryId()
	 {
	    return 8;
	 }


   

   private short finiteStateType[] = { 
       -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 7, -1, -1, -1, 1, -1, -1, -1, -1, 2, 5, -1, -1, -1, -1, -1, -1, -1, 6, -1, 3, 4, 0, 5, -1, -1, 5, -1
  }
;
   private String finiteStateName[] = { 
       "ignore","Lavanda$Body","Lavanda$House","Lavanda$Identifier","Lavanda$separa","Lavanda$Number","Lavanda$Date","Lavanda$ReservedWords","Lavanda$ignore",null
  }
;
   private short edges[][] = {  // max char 122
                        {9, 119, -1, -1, 37, 37, -1, -1, 37, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 37, -1, -1, -1, -1, -1, -1, -1, 36, 36, -1, -1, 36, 36, -1, -1, 38, 38, 38, 25, 25, 25, 25, 25, 25, 25, -1, -1, -1, -1, 36, -1, -1, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, -1, -1, -1, -1, -1, -1, -1, 16, 39, -1, -1, 11, -1, 20, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 40 }, 
                        {105, 105, -1, -1, 2 }, 
                        {116, 116, -1, -1, 3 }, 
                        {101, 101, -1, -1, 15 }, 
                        {111, 111, -1, -1, 5 }, 
                        {114, 114, -1, -1, 15 }, 
                        {116, 116, -1, -1, 7 }, 
                        {111, 111, -1, -1, 8 }, 
                        {110, 110, -1, -1, 15 }, 
                        {111, 111, -1, -1, 10 }, 
                        {108, 108, -1, -1, 15 }, 
                        {105, 105, -1, -1, 12 }, 
                        {98, 98, -1, -1, 13 }, 
                        {101, 101, -1, -1, 14 }, 
                        {114, 114, -1, -1, 15 }, 
                        {122, 122, -1, -1, -1 }, 
                        {111, 111, -1, -1, 17 }, 
                        {100, 100, -1, -1, 18 }, 
                        {121, 121, -1, -1, 19 }, 
                        {122, 122, -1, -1, -1 }, 
                        {111, 111, -1, -1, 21 }, 
                        {117, 117, -1, -1, 22 }, 
                        {115, 115, -1, -1, 23 }, 
                        {101, 101, -1, -1, 24 }, 
                        {122, 122, -1, -1, -1 }, 
                        {48, 57, -1, -1, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25 }, 
                        {48, 57, -1, -1, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27 }, 
                        {48, 57, -1, -1, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28 }, 
                        {45, 45, -1, -1, 29 }, 
                        {48, 50, -1, -1, 30, 30, 30 }, 
                        {48, 57, -1, -1, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31 }, 
                        {48, 57, -1, -1, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32 }, 
                        {48, 57, -1, -1, 33, 33, 33, 33, 33, 33, 33, 33, 33, 33 }, 
                        {122, 122, -1, -1, -1 }, 
                        {97, 122, -1, -1, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35 }, 
                        {97, 122, -1, -1, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35 }, 
                        {122, 122, -1, -1, -1 }, 
                        {9, 32, -1, -1, 37, 37, -1, -1, 37, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 37 }, 
                        {48, 57, -1, -1, 41, 41, 41, 41, 41, 41, 41, 41, 41, 41 }, 
                        {111, 111, -1, -1, 42 }, 
                        {104, 111, -1, -1, 1, -1, -1, -1, -1, -1, -1, 9 }, 
                        {45, 57, -1, -1, 26, -1, -1, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25 }, 
                        {108, 116, -1, -1, 4, -1, -1, -1, -1, -1, -1, -1, 6 }
  }
;
   private short allStateTypes[][] = { { },
   { },
   { },
   { },
   { },
   { },
   { },
   { },
   { },
   { },
   { },
   { },
   { },
   { },
   { },
   {7 },
   { },
   { },
   { },
   {1 },
   { },
   { },
   { },
   { },
   {2 },
   {5 },
   { },
   { },
   { },
   { },
   { },
   { },
   { },
   {6 },
   { },
   {3 },
   {4 },
   {0, 8 },
   {5 },
   { },
   { },
   {5 },
   { }};

   private Vector tokens;
   private CToken lastToken = null;
   private int NewState;
   private int LastCurrent;
   

   private Vector finiteStateTypes[]= new Vector[42+1];


}

   private short finiteStateTypeAll[] = { 
       -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 7, -1, -1, -1, 1, -1, -1, -1, -1, 2, 5, -1, -1, -1, -1, -1, -1, -1, 6, -1, 3, 4, 0, 5, -1, -1, 5, -1
  }
;
   private String finiteStateNameAll[] = { 
       "ignore","Lavanda$Body","Lavanda$House","Lavanda$Identifier","Lavanda$separa","Lavanda$Number","Lavanda$Date","Lavanda$ReservedWords","Lavanda$ignore",null
  }
;
   
}


