// 0. PROGRAM                 ::= IDORFUNCDECL <begin> STMTS <end>.
{
   IDORFUNCDECL.inEnv = new CEnvironment();
   STMTS.env = IDORFUNCDECL.outEnv;
   STMTS.infunc = new CFunction(STMTS.env);
   PROGRAM.func = STMTS.outfunc;
   PROGRAM.value = PROGRAM.func.Evaluate();
}


// 1. IDORFUNCDECL       ::= DECLS FUNCDECLS.
{
   
   IDORFUNCDECL.outEnv = FUNCDECLS.outEnv;
   DECLS.inEnv = IDORFUNCDECL.inEnv;
   DECLS.is_global = true;
   FUNCDECLS.inEnv = DECLS.outEnv;
}

// 2. DECLS                	::= DECL <;> DECLS.
{
   
   DECLS[0].outEnv = DECLS[1].outEnv;
   DECL.inEnv = DECLS[0].inEnv;
   DECLS[1].inEnv = DECL.outEnv;
   DECL.is_global = DECLS[0].is_global;
   DECLS[1].is_global = DECLS[0].is_global;
}

// 3. DECLS                	::=  <>.
{
   DECLS.outEnv = DECLS.inEnv;
}

// 4. DECL                   	::= int #ID.
{
   
   DECL.outEnv = DECL.is_global ?
	 DECL.inEnv.update_str(#ID.value(),
	                       new Denotval(dnVARIABLE, dnINTEGER, (new obj_value(0, null))))  :
   DECL.inEnv.add_local_env(#ID.value(),
                            new Denotval(dnVARIABLE, dnINTEGER, (new obj_value(0,null))));
}

//-------------------------------------------------------------------------------------------------------------
// 5. FUNCDECLS         	::= FUNCTION FUNCDECLS.
{
   FUNCDECLS[0].outEnv = FUNCDECLS[1].outEnv;
   FUNCDECLS[1].inEnv = FUNCTION.outEnv;
   FUNCTION.inEnv = FUNCDECLS[0].inEnv;
}
//-------------------------------------------------------------------------------------------------------------
// 6. FUNCDECLS         	::=  <>.

{
   FUNCDECLS.outEnv = FUNCDECLS.inEnv;
}

//-------------------------------------------------------------------------------------------------------------
// 7. FUNCTION            	::= #ID <(> PARAMDEFS <)> FUNCBODY.
{
   PARAMDEFS.inEnv = new CEnvironment((new Idmap()).empty_map(), FUNCTION.inEnv.Global());
   FUNCBODY.inEnv = PARAMDEFS.outEnv;
   FUNCTION.denot = new Denotval(dnFUNCTION, dnINTEGER,
				  (new obj_value( 0, new FuncDenot( PARAMDEFS.args,
                                       FUNCBODY.outEnv, FUNCBODY.func))));
   FUNCTION.outEnv = FUNCTION.inEnv.update_str(#ID.value(),
					       FUNCTION.denot);
}
//-------------------------------------------------------------------------------------------------------------
// 8. PARAMDEFS       	::= #ID PARAMD.

{
   PARAMD.inEnv = PARAMDEFS.inEnv.add_local_env(#ID.value(),
						new Denotval(dnVARIABLE, dnINTEGER, (new obj_value(0,NULL))));
   PARAMDEFS.outEnv = PARAMD.outEnv;
   PARAMD.in_args = (new Arguments())->Add(#ID.value());
   PARAMDEFS.args = PARAMD.out_args;
}

//-------------------------------------------------------------------------------------------------------------
// 9. PARAMDEFS       	::= <>.

{
   PARAMDEFS.outEnv = PARAMDEFS.inEnv;
   PARAMDEFS.args = null;
}
//-------------------------------------------------------------------------------------------------------------
// 10. PARAMD     		::= <,> #ID PARAMD.
{
   PARAMD[1].inEnv = PARAMD[0].inEnv->add_local_env(#ID.value(),
						    new Denotval(dnVARIABLE, dnINTEGER, (new obj_value(0,null))));
   PARAMD[0].outEnv = PARAMD[1].outEnv;
   
   PARAMD[1].in_args = PARAMD[0].in_args.Add(#ID.value());
   PARAMD[0].out_args = PARAMD[1].out_args;
}
//-------------------------------------------------------------------------------------------------------------
// 11. PARAMD     		::=  <>.

{
   PARAMD.outEnv = PARAMD.inEnv;
   PARAMD.out_args = PARAMD.in_args;
}
//-------------------------------------------------------------------------------------------------------------
// 12. FUNCBODY 		::= DECLS STMTS <return> EXP <;>.
{
   DECLS.is_global = false;
   EXP.inExp = new CExpression(DECLS.outEnv);
   DECLS.inEnv = FUNCBODY.inEnv; 
   STMTS.env = DECLS.outEnv;
   STMTS.infunc = new CFunction(STMTS.env);
   FUNCBODY.outEnv =STMTS.env;
   FUNCBODY.func = STMTS.outfunc.AddStatement(new SStatement(NULL, 
							     stReturn, EXP.outExp, "")) ;
}
//-------------------------------------------------------------------------------------------------------------
// 13. STMTS                 	::= STMT <;> STMTS.
{
   STMT.env = STMTS[0].env;
   STMTS[1].env = STMTS[0].env;
   STMTS[1].infunc = STMTS[0].infunc->AddStatement(STMT[0].stat);
   STMTS[0].outfunc = STMTS[1].outfunc;
}
//-------------------------------------------------------------------------------------------------------------
// 14.  STMTS                 	::= <>.
{
   STMTS.outfunc = STMTS.infunc;
}

//-------------------------------------------------------------------------------------------------------------
// 15. STMT                   	::= #ID <:=> EXP .

{
   EXP.inExp = new CExpression(STMT.env);
   STMT.stat = new SStatement(NULL, stEq,  EXP.outExp, 
			      #ID.value);
}

//-------------------------------------------------------------------------------------------------------------
// 16. EXP                      	::= TERM EEXP.

{
   EXP.outExp = EEXP.outExp;
   TERM.inExp = EXP.inExp;
   EEXP.inExp = TERM.outExp;
}

//-------------------------------------------------------------------------------------------------------------
// 17. EEXP                   	::= <+> TERM EEXP.
{
   EEXP[0].outExp = EEXP[1].outExp;
   TERM.inExp = EEXP[0].inExp.Add("+", exOperator);
   EEXP[1].inExp = TERM.outExp;
}

//-------------------------------------------------------------------------------------------------------------
// 18.  EEXP                   	::=  <>.
{
   EEXP.outExp =EEXP.inExp ;
}

//-------------------------------------------------------------------------------------------------------------
// 19. TERM                  	::= FACTOR TTERM.

{
   TERM.outExp = TTERM.outExp;
   FACTOR.inExp = TERM.inExp;
   TTERM.inExp = FACTOR.outExp;
}

//-------------------------------------------------------------------------------------------------------------
// 20. TTERM 			::= <*> FACTOR TTERM.

{
   TTERM[0].outExp = TTERM[1].outExp;
   FACTOR.inExp = TTERM[0].inExp.Add("*", exOperator);
   TTERM[1].inExp = FACTOR.outExp;
}

//-------------------------------------------------------------------------------------------------------------
// 21. TTERM 			::=  <>.

{
   TTERM.outExp = TTERM.inExp;
}

//-------------------------------------------------------------------------------------------------------------
// 22. FACTOR			::= <(> EXP <)>.

{
   FACTOR.outExp = EXP.outExp.Add(")",exOperator);
   EXP.inExp = FACTOR.inExp.Add(")",exOperator);
}
//-------------------------------------------------------------------------------------------------------------
// 23. FACTOR			::= #NUMBER.
{
   FACTOR.outExp = FACTOR.inExp.Add(#NUMBER.value(),
				      exNumber);
}

//-------------------------------------------------------------------------------------------------------------
// 24. FACTOR			::= #ID OPFUNCALL.
{
   FACTOR.outExp =  (OPFUNCALL.is_funcall) ?
     FACTOR.inExp->Add(#ID.value(),
		       exFunctionCall, OPFUNCALL.real_args) :
   FACTOR.inExp->Add(#ID.value(),
		      exId);
   
}

//-------------------------------------------------------------------------------------------------------------
// 25. OPFUNCALL		::= <(> ARGS <)> .
{
   OPFUNCALL.is_funcall = true;
   OPFUNCALL.real_args = ARGS.real_args;
}

//-------------------------------------------------------------------------------------------------------------
// 26. OPFUNCALL		::=  <>.
{
   OPFUNCALL.is_funcall = false;
   OPFUNCALL.real_args = NULL;
}
 
//-------------------------------------------------------------------------------------------------------------
// 27.  ARGS				::= #ID ARGREST.
{
   ARGREST.in_real_args = (new RArguments())->Add( #ID.value(), arId);
   ARGS.real_args = ARGREST.out_real_args;
}

//-------------------------------------------------------------------------------------------------------------
// 28.  ARGS				::=  #NUMBER ARGREST.
{
   ARGREST.in_real_args = (new RArguments())->Add(#NUMBER.value()), arNum);
   ARGS.real_args = ARGREST.out_real_args;
}

//-------------------------------------------------------------------------------------------------------------
// 29.  ARGS				::=  <>.
{
   ARGS.real_args = null;
}
//-------------------------------------------------------------------------------------------------------------
// 30.  ARGREST			::= <,> #ID ARGREST.
{
   ARGREST[1].in_real_args = ARGREST[0].in_real_args->Add( #ID.value(), arId);
   ARGREST[0].out_real_args = ARGREST[1].out_real_args;
}

//-------------------------------------------------------------------------------------------------------------
// 31.  ARGREST			::=  <,> #NUMBER ARGREST.
{
   ARGREST[1].in_real_args = ARGREST[0].in_real_args->Add(#NUMBER.value(), arNum); 
   ARGREST[0].out_real_args = ARGREST[1].out_real_args;
}

//-------------------------------------------------------------------------------------------------------------
// 32.  ARGREST			::= <>.

{
   ARGREST.out_real_args = ARGREST.in_real_args;
}
